// ============================================================================
//
// Copyright (C) 2006-2012 Talend Inc. - www.talend.com
//
// This source code is available under agreement available at
// %InstallDIR%\features\org.talend.rcp.branding.%PRODUCTNAME%\%PRODUCTNAME%license.txt
//
// You should have received a copy of the agreement
// along with this program; if not, write to Talend SA
// 9 rue Pages 92150 Suresnes, France
//
// ============================================================================
package org.talend.oracle;

import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.Calendar;
import java.util.TimeZone;

import routines.system.TalendTimestampWithTZ;

/**
 * created by bchen on Oct 15, 2012 Detailled comment
 * 
 */
public class OracleTSTZUtil {

    public static TalendTimestampWithTZ toTalendTSTZ(byte[] oracleTSTZs) throws SQLException {
        OracleTSTZ oracleTSTZ = new OracleTSTZ(oracleTSTZs);

        Calendar calendar = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
        calendar.clear();

        // year
        calendar.set(Calendar.YEAR, oracleTSTZ.getYear());
        // month
        calendar.set(Calendar.MONTH, oracleTSTZ.getMonth() - 1);
        // day
        calendar.set(Calendar.DAY_OF_MONTH, oracleTSTZ.getDay());
        // hour
        calendar.set(Calendar.HOUR_OF_DAY, oracleTSTZ.getHour() - 1);
        // minute
        calendar.set(Calendar.MINUTE, oracleTSTZ.getMin() - 1);
        // second
        calendar.set(Calendar.SECOND, oracleTSTZ.getSecond() - 1);
        long time = calendar.getTime().getTime();
        Timestamp timestampWithLocalTZ = new Timestamp(time);
        // nano
        timestampWithLocalTZ.setNanos(oracleTSTZ.getNano());

        return new TalendTimestampWithTZ(timestampWithLocalTZ, TimeZone.getTimeZone(oracleTSTZ.getZone()));
    }
}
