package routines;

import java.io.IOException;
import java.net.InetAddress;
import java.net.Socket;

import javax.net.SocketFactory;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.TrustManager;
/*
 * user specification: the function's comment should contain keys as follows: 1. write about the function's comment.but
 * it must be before the "{talendTypes}" key.
 * 
 * 2. {talendTypes} 's value must be talend Type, it is required . its value should be one of: String, char | Character,
 * long | Long, int | Integer, boolean | Boolean, byte | Byte, Date, double | Double, float | Float, Object, short |
 * Short
 * 
 * 3. {Category} define a category for the Function. it is required. its value is user-defined .
 * 
 * 4. {param} 's format is: {param} <type>[(<default value or closed list values>)] <name>[ : <comment>]
 * 
 * <type> 's value should be one of: string, int, list, double, object, boolean, long, char, date. <name>'s value is the
 * Function's parameter name. the {param} is optional. so if you the Function without the parameters. the {param} don't
 * added. you can have many parameters for the Function.
 * 
 * 5. {example} gives a example for the Function. it is optional.
 */
public class LazySSLSocketFactory extends SSLSocketFactory {
	private SSLSocketFactory factory;
	public LazySSLSocketFactory() {
		try {
			SSLContext sslcontext = SSLContext.getInstance("TLS");
			sslcontext.init(
					null, // No KeyManager required
					new TrustManager[] { new LazyTrustManager() },
					new java.security.SecureRandom());
			factory = (SSLSocketFactory) sslcontext.getSocketFactory();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	public static SocketFactory getDefault() {
		return new LazySSLSocketFactory();
	}
	public Socket createSocket() throws IOException {
		return factory.createSocket();
	}
	public Socket createSocket(Socket socket, String s, int i, boolean flag)
	throws IOException {
		return factory.createSocket(socket, s, i, flag);
	}
	public Socket createSocket(InetAddress inaddr, int i, InetAddress inaddr1,
			int j) throws IOException {
		return factory.createSocket(inaddr, i, inaddr1, j);
	}
	public Socket createSocket(InetAddress inaddr, int i) throws IOException {
		return factory.createSocket(inaddr, i);
	}
	public Socket createSocket(String s, int i, InetAddress inaddr, int j)
	throws IOException {
		return factory.createSocket(s, i, inaddr, j);
	}
	public Socket createSocket(String s, int i) throws IOException {
		return factory.createSocket(s, i);
	}
	public String[] getDefaultCipherSuites() {
		return factory.getSupportedCipherSuites();
	}
	public String[] getSupportedCipherSuites() {
		return factory.getSupportedCipherSuites();
	}
}