// ============================================================================
//
// Copyright (c) 2006-2015, Talend Inc.
//
// This source code has been automatically generated by_Talend Open Studio for Data Integration
// / Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


package ldap.sgbm_export_0_8;

import routines.DataOperation;
import routines.LazyTrustManager;
import routines.TalendDataGenerator;
import routines.Base64;
import routines.Relational;
import routines.Mathematical;
import routines.Numeric;
import routines.ADConnection;
import routines.UNIMES;
import routines.TalendStringUtil;
import routines.TalendString;
import routines.StringHandling;
import routines.TalendDate;
import routines.MD4;
import routines.LazySSLSocketFactory;
import routines.system.*;
import routines.system.api.*;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.math.BigDecimal;
import java.io.ByteArrayOutputStream;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.ObjectOutputStream;
import java.io.ObjectInputStream;
import java.io.IOException;
import java.util.Comparator;
 





@SuppressWarnings("unused")

/**
 * Job: sgbm_export Purpose: <br>
 * Description:  <br>
 * @author user@talend.com
 * @version 6.5.1.20180116_1512
 * @status 
 */
public class sgbm_export implements TalendJob {



	public final Object obj = new Object();

	// for transmiting parameters purpose
	private Object valueObject = null;

	public Object getValueObject() {
		return this.valueObject;
	}

	public void setValueObject(Object valueObject) {
		this.valueObject = valueObject;
	}
	
	private final static String defaultCharset = java.nio.charset.Charset.defaultCharset().name();

	
	private final static String utf8Charset = "UTF-8";
	//contains type for every context property
	public class PropertiesWithType extends java.util.Properties {
		private static final long serialVersionUID = 1L;
		private java.util.Map<String,String> propertyTypes = new java.util.HashMap<>();
		
		public PropertiesWithType(java.util.Properties properties){
			super(properties);
		}
		public PropertiesWithType(){
			super();
		}
		
		public void setContextType(String key, String type) {
			propertyTypes.put(key,type);
		}
	
		public String getContextType(String key) {
			return propertyTypes.get(key);
		}
	}
	
	// create and load default properties
	private java.util.Properties defaultProps = new java.util.Properties();
	// create application properties with default
	public class ContextProperties extends PropertiesWithType {

		private static final long serialVersionUID = 1L;

		public ContextProperties(java.util.Properties properties){
			super(properties);
		}
		public ContextProperties(){
			super();
		}

		public void synchronizeContext(){
			
			if(sigb_record_type != null){
				
					this.setProperty("sigb_record_type", sigb_record_type.toString());
				
			}
			
			if(sigb_user_group != null){
				
					this.setProperty("sigb_user_group", sigb_user_group.toString());
				
			}
			
			if(sigb_user_group_desc != null){
				
					this.setProperty("sigb_user_group_desc", sigb_user_group_desc.toString());
				
			}
			
			if(sigb_external != null){
				
					this.setProperty("sigb_external", sigb_external.toString());
				
			}
			
			if(sigb_external_desc != null){
				
					this.setProperty("sigb_external_desc", sigb_external_desc.toString());
				
			}
			
			if(sigb_external_id != null){
				
					this.setProperty("sigb_external_id", sigb_external_id.toString());
				
			}
			
			if(sigb_active != null){
				
					this.setProperty("sigb_active", sigb_active.toString());
				
			}
			
			if(sigb_id_type_eppn != null){
				
					this.setProperty("sigb_id_type_eppn", sigb_id_type_eppn.toString());
				
			}
			
			if(sigb_cataloger_level_desc != null){
				
					this.setProperty("sigb_cataloger_level_desc", sigb_cataloger_level_desc.toString());
				
			}
			
			if(sigb_cataloger_level != null){
				
					this.setProperty("sigb_cataloger_level", sigb_cataloger_level.toString());
				
			}
			
			if(sigb_param_file != null){
				
					this.setProperty("sigb_param_file", sigb_param_file.toString());
				
			}
			
			if(oracle_schema != null){
				
					this.setProperty("oracle_schema", oracle_schema.toString());
				
			}
			
			if(oracle_server != null){
				
					this.setProperty("oracle_server", oracle_server.toString());
				
			}
			
			if(oracle_port != null){
				
					this.setProperty("oracle_port", oracle_port.toString());
				
			}
			
			if(oracle_login != null){
				
					this.setProperty("oracle_login", oracle_login.toString());
				
			}
			
			if(oracle_sid != null){
				
					this.setProperty("oracle_sid", oracle_sid.toString());
				
			}
			
			if(oracle_password != null){
				
					this.setProperty("oracle_password", oracle_password.toString());
				
			}
			
			if(sigb_files_dir != null){
				
					this.setProperty("sigb_files_dir", sigb_files_dir.toString());
				
			}
			
			if(sigb_biu_dir != null){
				
					this.setProperty("sigb_biu_dir", sigb_biu_dir.toString());
				
			}
			
			if(sigb_file_name != null){
				
					this.setProperty("sigb_file_name", sigb_file_name.toString());
				
			}
			
			if(sigb_biu_password != null){
				
					this.setProperty("sigb_biu_password", sigb_biu_password.toString());
				
			}
			
			if(sigb_biu_cle_publique != null){
				
					this.setProperty("sigb_biu_cle_publique", sigb_biu_cle_publique.toString());
				
			}
			
			if(sigb_biu_username != null){
				
					this.setProperty("sigb_biu_username", sigb_biu_username.toString());
				
			}
			
			if(sigb_biu_host != null){
				
					this.setProperty("sigb_biu_host", sigb_biu_host.toString());
				
			}
			
			if(sigb_biu_port != null){
				
					this.setProperty("sigb_biu_port", sigb_biu_port.toString());
				
			}
			
		}

public String sigb_record_type;
public String getSigb_record_type(){
	return this.sigb_record_type;
}
public String sigb_user_group;
public String getSigb_user_group(){
	return this.sigb_user_group;
}
public String sigb_user_group_desc;
public String getSigb_user_group_desc(){
	return this.sigb_user_group_desc;
}
public String sigb_external;
public String getSigb_external(){
	return this.sigb_external;
}
public String sigb_external_desc;
public String getSigb_external_desc(){
	return this.sigb_external_desc;
}
public String sigb_external_id;
public String getSigb_external_id(){
	return this.sigb_external_id;
}
public String sigb_active;
public String getSigb_active(){
	return this.sigb_active;
}
public String sigb_id_type_eppn;
public String getSigb_id_type_eppn(){
	return this.sigb_id_type_eppn;
}
public String sigb_cataloger_level_desc;
public String getSigb_cataloger_level_desc(){
	return this.sigb_cataloger_level_desc;
}
public String sigb_cataloger_level;
public String getSigb_cataloger_level(){
	return this.sigb_cataloger_level;
}
public String sigb_param_file;
public String getSigb_param_file(){
	return this.sigb_param_file;
}
public String oracle_schema;
public String getOracle_schema(){
	return this.oracle_schema;
}
public String oracle_server;
public String getOracle_server(){
	return this.oracle_server;
}
public String oracle_port;
public String getOracle_port(){
	return this.oracle_port;
}
public String oracle_login;
public String getOracle_login(){
	return this.oracle_login;
}
public String oracle_sid;
public String getOracle_sid(){
	return this.oracle_sid;
}
public String oracle_password;
public String getOracle_password(){
	return this.oracle_password;
}
public String sigb_files_dir;
public String getSigb_files_dir(){
	return this.sigb_files_dir;
}
public String sigb_biu_dir;
public String getSigb_biu_dir(){
	return this.sigb_biu_dir;
}
public String sigb_file_name;
public String getSigb_file_name(){
	return this.sigb_file_name;
}
public String sigb_biu_password;
public String getSigb_biu_password(){
	return this.sigb_biu_password;
}
public String sigb_biu_cle_publique;
public String getSigb_biu_cle_publique(){
	return this.sigb_biu_cle_publique;
}
public String sigb_biu_username;
public String getSigb_biu_username(){
	return this.sigb_biu_username;
}
public String sigb_biu_host;
public String getSigb_biu_host(){
	return this.sigb_biu_host;
}
public Integer sigb_biu_port;
public Integer getSigb_biu_port(){
	return this.sigb_biu_port;
}
	}
	private ContextProperties context = new ContextProperties();
	public ContextProperties getContext() {
		return this.context;
	}
	private final String jobVersion = "0.8";
	private final String jobName = "sgbm_export";
	private final String projectName = "LDAP";
	public Integer errorCode = null;
	private String currentComponent = "";
	
		private final java.util.Map<String, Object> globalMap = new java.util.HashMap<String, Object>();
        private final static java.util.Map<String, Object> junitGlobalMap = new java.util.HashMap<String, Object>();
	
		private final java.util.Map<String, Long> start_Hash = new java.util.HashMap<String, Long>();
		private final java.util.Map<String, Long> end_Hash = new java.util.HashMap<String, Long>();
		private final java.util.Map<String, Boolean> ok_Hash = new java.util.HashMap<String, Boolean>();
		public  final java.util.List<String[]> globalBuffer = new java.util.ArrayList<String[]>();
	

private RunStat runStat = new RunStat();

	// OSGi DataSource
	private final static String KEY_DB_DATASOURCES = "KEY_DB_DATASOURCES";

	public void setDataSources(java.util.Map<String, javax.sql.DataSource> dataSources) {
		java.util.Map<String, routines.system.TalendDataSource> talendDataSources = new java.util.HashMap<String, routines.system.TalendDataSource>();
		for (java.util.Map.Entry<String, javax.sql.DataSource> dataSourceEntry : dataSources.entrySet()) {
			talendDataSources.put(dataSourceEntry.getKey(), new routines.system.TalendDataSource(dataSourceEntry.getValue()));
		}
		globalMap.put(KEY_DB_DATASOURCES, talendDataSources);
	}


private final java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream();
private final java.io.PrintStream errorMessagePS = new java.io.PrintStream(new java.io.BufferedOutputStream(baos));

public String getExceptionStackTrace() {
	if ("failure".equals(this.getStatus())) {
		errorMessagePS.flush();
		return baos.toString();
	}
	return null;
}

private Exception exception;

public Exception getException() {
	if ("failure".equals(this.getStatus())) {
		return this.exception;
	}
	return null;
}

private class TalendException extends Exception {

	private static final long serialVersionUID = 1L;

	private java.util.Map<String, Object> globalMap = null;
	private Exception e = null;
	private String currentComponent = null;
	private String virtualComponentName = null;
	
	public void setVirtualComponentName (String virtualComponentName){
		this.virtualComponentName = virtualComponentName;
	}

	private TalendException(Exception e, String errorComponent, final java.util.Map<String, Object> globalMap) {
		this.currentComponent= errorComponent;
		this.globalMap = globalMap;
		this.e = e;
	}

	public Exception getException() {
		return this.e;
	}

	public String getCurrentComponent() {
		return this.currentComponent;
	}

	
    public String getExceptionCauseMessage(Exception e){
        Throwable cause = e;
        String message = null;
        int i = 10;
        while (null != cause && 0 < i--) {
            message = cause.getMessage();
            if (null == message) {
                cause = cause.getCause();
            } else {
                break;          
            }
        }
        if (null == message) {
            message = e.getClass().getName();
        }   
        return message;
    }

	@Override
	public void printStackTrace() {
		if (!(e instanceof TalendException || e instanceof TDieException)) {
			if(virtualComponentName!=null && currentComponent.indexOf(virtualComponentName+"_")==0){
				globalMap.put(virtualComponentName+"_ERROR_MESSAGE",getExceptionCauseMessage(e));
			}
			globalMap.put(currentComponent+"_ERROR_MESSAGE",getExceptionCauseMessage(e));
			System.err.println("Exception in component " + currentComponent + " (" + jobName + ")");
		}
		if (!(e instanceof TDieException)) {
			if(e instanceof TalendException){
				e.printStackTrace();
			} else {
				e.printStackTrace();
				e.printStackTrace(errorMessagePS);
				sgbm_export.this.exception = e;
			}
		}
		if (!(e instanceof TalendException)) {
		try {
			for (java.lang.reflect.Method m : this.getClass().getEnclosingClass().getMethods()) {
				if (m.getName().compareTo(currentComponent + "_error") == 0) {
					m.invoke(sgbm_export.this, new Object[] { e , currentComponent, globalMap});
					break;
				}
			}

			if(!(e instanceof TDieException)){
			}
		} catch (Exception e) {
			this.e.printStackTrace();
		}
		}
	}
}

			public void tPrejob_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tPrejob_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tFileInputProperties_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tFileInputProperties_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tContextLoad_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tFileInputProperties_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tLogRow_2_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tFileInputProperties_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleConnection_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleConnection_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tSCPConnection_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tSCPConnection_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleInput_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tFileOutputXML_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tFileArchive_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tFileArchive_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tSCPPut_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tFileArchive_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleInput_2_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_2_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleInput_3_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_3_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleInput_4_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_4_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleInput_5_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_5_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tPostjob_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tPostjob_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tSCPClose_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tSCPClose_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tOracleClose_1_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleClose_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tAdvancedXMLMapHash_mail_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_2_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tAdvancedXMLMapHash_adresse_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_3_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tAdvancedXMLMapHash_telephone_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_4_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tAdvancedXMLMapHash_statistiques_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_5_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tXMLMap_1_TXMLMAP_OUT_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
							tXMLMap_1_TXMLMAP_IN_error(exception, errorComponent, globalMap);
						
						}
					
			public void tXMLMap_1_TXMLMAP_IN_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tOracleInput_1_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tPrejob_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tFileInputProperties_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleConnection_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tSCPConnection_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleInput_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tFileArchive_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleInput_2_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleInput_3_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleInput_4_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleInput_5_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tPostjob_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tSCPClose_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tOracleClose_1_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
		





public void tPrejob_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tPrejob_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tPrejob_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tPrejob_1", false);
		start_Hash.put("tPrejob_1", System.currentTimeMillis());
		
	
	currentComponent="tPrejob_1";

	
		int tos_count_tPrejob_1 = 0;
		
    	class BytesLimit65535_tPrejob_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tPrejob_1().limitLog4jByte();

 



/**
 * [tPrejob_1 begin ] stop
 */
	
	/**
	 * [tPrejob_1 main ] start
	 */

	

	
	
	currentComponent="tPrejob_1";

	

 


	tos_count_tPrejob_1++;

/**
 * [tPrejob_1 main ] stop
 */
	
	/**
	 * [tPrejob_1 end ] start
	 */

	

	
	
	currentComponent="tPrejob_1";

	

 

ok_Hash.put("tPrejob_1", true);
end_Hash.put("tPrejob_1", System.currentTimeMillis());

				if(execStat){   
   	 				runStat.updateStatOnConnection("OnComponentOk1", 0, "ok");
				}
				tFileInputProperties_1Process(globalMap);



/**
 * [tPrejob_1 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tPrejob_1 finally ] start
	 */

	

	
	
	currentComponent="tPrejob_1";

	

 



/**
 * [tPrejob_1 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tPrejob_1_SUBPROCESS_STATE", 1);
	}
	


public static class row6Struct implements routines.system.IPersistableRow<row6Struct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String key;

				public String getKey () {
					return this.key;
				}
				
			    public String value;

				public String getValue () {
					return this.value;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.key = readString(dis);
					
					this.value = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.key,dos);
					
					// String
				
						writeString(this.value,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("key="+key);
		sb.append(",value="+value);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(row6Struct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class row5Struct implements routines.system.IPersistableRow<row5Struct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String key;

				public String getKey () {
					return this.key;
				}
				
			    public String value;

				public String getValue () {
					return this.value;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.key = readString(dis);
					
					this.value = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.key,dos);
					
					// String
				
						writeString(this.value,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("key="+key);
		sb.append(",value="+value);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(row5Struct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tFileInputProperties_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tFileInputProperties_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		row5Struct row5 = new row5Struct();
row5Struct row6 = row5;





	
	/**
	 * [tLogRow_2 begin ] start
	 */

	

	
		
		ok_Hash.put("tLogRow_2", false);
		start_Hash.put("tLogRow_2", System.currentTimeMillis());
		
	
	currentComponent="tLogRow_2";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("row6" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tLogRow_2 = 0;
		
    	class BytesLimit65535_tLogRow_2{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tLogRow_2().limitLog4jByte();

	///////////////////////
	
		final String OUTPUT_FIELD_SEPARATOR_tLogRow_2 = "|";
		java.io.PrintStream consoleOut_tLogRow_2 = null;	

 		StringBuilder strBuffer_tLogRow_2 = null;
		int nb_line_tLogRow_2 = 0;
///////////////////////    			



 



/**
 * [tLogRow_2 begin ] stop
 */



	
	/**
	 * [tContextLoad_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tContextLoad_1", false);
		start_Hash.put("tContextLoad_1", System.currentTimeMillis());
		
	
	currentComponent="tContextLoad_1";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("row5" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tContextLoad_1 = 0;
		
    	class BytesLimit65535_tContextLoad_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tContextLoad_1().limitLog4jByte();
	java.util.List<String> assignList_tContextLoad_1 = new java.util.ArrayList<String>();
	java.util.List<String> newPropertyList_tContextLoad_1 = new java.util.ArrayList<String>();
	java.util.List<String> noAssignList_tContextLoad_1 = new java.util.ArrayList<String>();
	int nb_line_tContextLoad_1 = 0;

 



/**
 * [tContextLoad_1 begin ] stop
 */



	
	/**
	 * [tFileInputProperties_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tFileInputProperties_1", false);
		start_Hash.put("tFileInputProperties_1", System.currentTimeMillis());
		
	
	currentComponent="tFileInputProperties_1";

	
		int tos_count_tFileInputProperties_1 = 0;
		
    	class BytesLimit65535_tFileInputProperties_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tFileInputProperties_1().limitLog4jByte();

	java.io.File file_tFileInputProperties_1 = new java.io.File(context.sigb_param_file);
	int nb_line_tFileInputProperties_1 = 0;
	java.util.Properties properties_tFileInputProperties_1 = new java.util.Properties();
	java.io.FileInputStream fis_tFileInputProperties_1=new java.io.FileInputStream(file_tFileInputProperties_1);
   	try{
		properties_tFileInputProperties_1.load(fis_tFileInputProperties_1);
		java.util.Enumeration enumeration_tFileInputProperties_1 = properties_tFileInputProperties_1.propertyNames();
		while (enumeration_tFileInputProperties_1.hasMoreElements()) {
			nb_line_tFileInputProperties_1++;
			row5.key = (String)enumeration_tFileInputProperties_1.nextElement();
			row5.value = (String)properties_tFileInputProperties_1.getProperty(row5.key);

 



/**
 * [tFileInputProperties_1 begin ] stop
 */
	
	/**
	 * [tFileInputProperties_1 main ] start
	 */

	

	
	
	currentComponent="tFileInputProperties_1";

	

 


	tos_count_tFileInputProperties_1++;

/**
 * [tFileInputProperties_1 main ] stop
 */

	
	/**
	 * [tContextLoad_1 main ] start
	 */

	

	
	
	currentComponent="tContextLoad_1";

	

			//row5
			//row5


			
				if(execStat){
					runStat.updateStatOnConnection("row5"+iterateId,1, 1);
				} 
			

		
        //////////////////////////
        String tmp_key_tContextLoad_1 = null;
                    String key_tContextLoad_1 = null;
                      if (row5.key != null){
                          tmp_key_tContextLoad_1 = row5.key.trim();
                        if ((tmp_key_tContextLoad_1.startsWith("#") || tmp_key_tContextLoad_1.startsWith("!") )){
                          tmp_key_tContextLoad_1 = null;
                        } else {
                          row5.key = tmp_key_tContextLoad_1;
                        }
                      }
                        if(row5.key != null) {
                    key_tContextLoad_1 =
                        row5.key;
                        }
                    String value_tContextLoad_1 = null;
                        if(row5.value != null) {
                    value_tContextLoad_1 =
                        row5.value;
                        }
				
				String currentValue_tContextLoad_1 = value_tContextLoad_1;
				

  if (tmp_key_tContextLoad_1 != null){
  try{
        if(key_tContextLoad_1!=null && "sigb_record_type".equals(key_tContextLoad_1))
        {
           context.sigb_record_type=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_user_group".equals(key_tContextLoad_1))
        {
           context.sigb_user_group=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_user_group_desc".equals(key_tContextLoad_1))
        {
           context.sigb_user_group_desc=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_external".equals(key_tContextLoad_1))
        {
           context.sigb_external=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_external_desc".equals(key_tContextLoad_1))
        {
           context.sigb_external_desc=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_external_id".equals(key_tContextLoad_1))
        {
           context.sigb_external_id=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_active".equals(key_tContextLoad_1))
        {
           context.sigb_active=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_id_type_eppn".equals(key_tContextLoad_1))
        {
           context.sigb_id_type_eppn=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_cataloger_level_desc".equals(key_tContextLoad_1))
        {
           context.sigb_cataloger_level_desc=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_cataloger_level".equals(key_tContextLoad_1))
        {
           context.sigb_cataloger_level=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_param_file".equals(key_tContextLoad_1))
        {
           context.sigb_param_file=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "oracle_schema".equals(key_tContextLoad_1))
        {
           context.oracle_schema=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "oracle_server".equals(key_tContextLoad_1))
        {
           context.oracle_server=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "oracle_port".equals(key_tContextLoad_1))
        {
           context.oracle_port=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "oracle_login".equals(key_tContextLoad_1))
        {
           context.oracle_login=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "oracle_sid".equals(key_tContextLoad_1))
        {
           context.oracle_sid=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "oracle_password".equals(key_tContextLoad_1))
        {
           context.oracle_password=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_files_dir".equals(key_tContextLoad_1))
        {
           context.sigb_files_dir=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_biu_dir".equals(key_tContextLoad_1))
        {
           context.sigb_biu_dir=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_file_name".equals(key_tContextLoad_1))
        {
           context.sigb_file_name=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_biu_password".equals(key_tContextLoad_1))
        {
           context.sigb_biu_password=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_biu_cle_publique".equals(key_tContextLoad_1))
        {
           context.sigb_biu_cle_publique=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_biu_username".equals(key_tContextLoad_1))
        {
           context.sigb_biu_username=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_biu_host".equals(key_tContextLoad_1))
        {
           context.sigb_biu_host=value_tContextLoad_1;
        }

        if(key_tContextLoad_1!=null && "sigb_biu_port".equals(key_tContextLoad_1))
        {

                context.sigb_biu_port=Integer.parseInt(value_tContextLoad_1);

        }


        if (context.getProperty(key_tContextLoad_1)!=null)
        {
            assignList_tContextLoad_1.add(key_tContextLoad_1);
        }else  {
            newPropertyList_tContextLoad_1.add(key_tContextLoad_1);
        }
        if(value_tContextLoad_1 == null){
            context.setProperty(key_tContextLoad_1, "");
        }else{
            context.setProperty(key_tContextLoad_1,value_tContextLoad_1);
        }
    }catch(java.lang.Exception e){
        System.err.println("Setting a value for the key \"" + key_tContextLoad_1 + "\" has failed. Error message: " + e.getMessage());
    }
        nb_line_tContextLoad_1++;
    }
        //////////////////////////

 
     row6 = row5;


	tos_count_tContextLoad_1++;

/**
 * [tContextLoad_1 main ] stop
 */

	
	/**
	 * [tLogRow_2 main ] start
	 */

	

	
	
	currentComponent="tLogRow_2";

	

			//row6
			//row6


			
				if(execStat){
					runStat.updateStatOnConnection("row6"+iterateId,1, 1);
				} 
			

		
///////////////////////		
						



				strBuffer_tLogRow_2 = new StringBuilder();




   				
	    		if(row6.key != null) { //              
                    							
       
				strBuffer_tLogRow_2.append(
				                String.valueOf(row6.key)							
				);


							
	    		} //  			

    			strBuffer_tLogRow_2.append("|");
    			


   				
	    		if(row6.value != null) { //              
                    							
       
				strBuffer_tLogRow_2.append(
				                String.valueOf(row6.value)							
				);


							
	    		} //  			
 

                    if (globalMap.get("tLogRow_CONSOLE")!=null)
                    {
                    	consoleOut_tLogRow_2 = (java.io.PrintStream) globalMap.get("tLogRow_CONSOLE");
                    }
                    else
                    {
                    	consoleOut_tLogRow_2 = new java.io.PrintStream(new java.io.BufferedOutputStream(System.out));
                    	globalMap.put("tLogRow_CONSOLE",consoleOut_tLogRow_2);
                    }
                    consoleOut_tLogRow_2.println(strBuffer_tLogRow_2.toString());
                    consoleOut_tLogRow_2.flush();
                    nb_line_tLogRow_2++;
//////

//////                    
                    
///////////////////////    			

 


	tos_count_tLogRow_2++;

/**
 * [tLogRow_2 main ] stop
 */






	
	/**
	 * [tFileInputProperties_1 end ] start
	 */

	

	
	
	currentComponent="tFileInputProperties_1";

	

		}
	}finally{
		if(fis_tFileInputProperties_1!=null){
			fis_tFileInputProperties_1.close();
		}
	}
globalMap.put("tFileInputProperties_1_NB_LINE", nb_line_tFileInputProperties_1);
 

ok_Hash.put("tFileInputProperties_1", true);
end_Hash.put("tFileInputProperties_1", System.currentTimeMillis());




/**
 * [tFileInputProperties_1 end ] stop
 */

	
	/**
	 * [tContextLoad_1 end ] start
	 */

	

	
	
	currentComponent="tContextLoad_1";

	
	
	java.util.Enumeration<?> enu_tContextLoad_1 = context.propertyNames();
    while(enu_tContextLoad_1.hasMoreElements())
    {           
    	String key_tContextLoad_1 = (String)enu_tContextLoad_1.nextElement();
        if(!assignList_tContextLoad_1.contains(key_tContextLoad_1) && !newPropertyList_tContextLoad_1.contains(key_tContextLoad_1))
        {
            noAssignList_tContextLoad_1.add(key_tContextLoad_1);
        }          
    } 

    String newPropertyStr_tContextLoad_1 = newPropertyList_tContextLoad_1.toString();
    String newProperty_tContextLoad_1 = newPropertyStr_tContextLoad_1.substring(1, newPropertyStr_tContextLoad_1.length() - 1);
    
    String noAssignStr_tContextLoad_1 = noAssignList_tContextLoad_1.toString();
    String noAssign_tContextLoad_1 = noAssignStr_tContextLoad_1.substring(1, noAssignStr_tContextLoad_1.length() - 1);
    
    globalMap.put("tContextLoad_1_KEY_NOT_INCONTEXT", newProperty_tContextLoad_1);
    globalMap.put("tContextLoad_1_KEY_NOT_LOADED", noAssign_tContextLoad_1);

    globalMap.put("tContextLoad_1_NB_LINE",nb_line_tContextLoad_1);

	List<String> parametersToEncrypt_tContextLoad_1 = new java.util.ArrayList<String>();
	
	
	resumeUtil.addLog("NODE", "NODE:tContextLoad_1", "", Thread.currentThread().getId() + "", "","","","",resumeUtil.convertToJsonText(context,parametersToEncrypt_tContextLoad_1));    
    
			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("row5"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tContextLoad_1", true);
end_Hash.put("tContextLoad_1", System.currentTimeMillis());

				if(execStat){   
   	 				runStat.updateStatOnConnection("OnComponentOk10", 0, "ok");
				}
				tOracleConnection_1Process(globalMap);



/**
 * [tContextLoad_1 end ] stop
 */

	
	/**
	 * [tLogRow_2 end ] start
	 */

	

	
	
	currentComponent="tLogRow_2";

	


//////
//////
globalMap.put("tLogRow_2_NB_LINE",nb_line_tLogRow_2);

///////////////////////    			

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("row6"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tLogRow_2", true);
end_Hash.put("tLogRow_2", System.currentTimeMillis());




/**
 * [tLogRow_2 end ] stop
 */






				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tFileInputProperties_1 finally ] start
	 */

	

	
	
	currentComponent="tFileInputProperties_1";

	

 



/**
 * [tFileInputProperties_1 finally ] stop
 */

	
	/**
	 * [tContextLoad_1 finally ] start
	 */

	

	
	
	currentComponent="tContextLoad_1";

	

 



/**
 * [tContextLoad_1 finally ] stop
 */

	
	/**
	 * [tLogRow_2 finally ] start
	 */

	

	
	
	currentComponent="tLogRow_2";

	

 



/**
 * [tLogRow_2 finally ] stop
 */






				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tFileInputProperties_1_SUBPROCESS_STATE", 1);
	}
	

public void tOracleConnection_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleConnection_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tOracleConnection_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleConnection_1", false);
		start_Hash.put("tOracleConnection_1", System.currentTimeMillis());
		
	
	currentComponent="tOracleConnection_1";

	
		int tos_count_tOracleConnection_1 = 0;
		
    	class BytesLimit65535_tOracleConnection_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleConnection_1().limitLog4jByte();
	

	
        String url_tOracleConnection_1 = "jdbc:oracle:thin:@" + context.oracle_server + ":" + context.oracle_port + ":" + context.oracle_sid;
    	globalMap.put("connectionType_" + "tOracleConnection_1", "ORACLE_SID");

	String dbUser_tOracleConnection_1 = context.oracle_login;
	
	
		
	final String decryptedPassword_tOracleConnection_1 = context.oracle_password; 
		String dbPwd_tOracleConnection_1 = decryptedPassword_tOracleConnection_1;
	

	java.sql.Connection conn_tOracleConnection_1 = null;
	
		
			String driverClass_tOracleConnection_1 = "oracle.jdbc.OracleDriver";
			java.lang.Class.forName(driverClass_tOracleConnection_1);
		
			conn_tOracleConnection_1 = java.sql.DriverManager.getConnection(url_tOracleConnection_1,dbUser_tOracleConnection_1,dbPwd_tOracleConnection_1);

		globalMap.put("conn_tOracleConnection_1", conn_tOracleConnection_1);
	if (null != conn_tOracleConnection_1) {
		
			conn_tOracleConnection_1.setAutoCommit(false);
	}
        globalMap.put("host_" + "tOracleConnection_1",context.oracle_server);
        globalMap.put("port_" + "tOracleConnection_1",context.oracle_port);
        globalMap.put("dbname_" + "tOracleConnection_1",context.oracle_sid);

	globalMap.put("conn_" + "tOracleConnection_1",conn_tOracleConnection_1);
	globalMap.put("dbschema_" + "tOracleConnection_1", context.oracle_schema);
	globalMap.put("username_" + "tOracleConnection_1",context.oracle_login);
	globalMap.put("password_" + "tOracleConnection_1",dbPwd_tOracleConnection_1);

 



/**
 * [tOracleConnection_1 begin ] stop
 */
	
	/**
	 * [tOracleConnection_1 main ] start
	 */

	

	
	
	currentComponent="tOracleConnection_1";

	

 


	tos_count_tOracleConnection_1++;

/**
 * [tOracleConnection_1 main ] stop
 */
	
	/**
	 * [tOracleConnection_1 end ] start
	 */

	

	
	
	currentComponent="tOracleConnection_1";

	

 

ok_Hash.put("tOracleConnection_1", true);
end_Hash.put("tOracleConnection_1", System.currentTimeMillis());

				if(execStat){   
   	 				runStat.updateStatOnConnection("OnComponentOk3", 0, "ok");
				}
				tSCPConnection_1Process(globalMap);



/**
 * [tOracleConnection_1 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleConnection_1 finally ] start
	 */

	

	
	
	currentComponent="tOracleConnection_1";

	

 



/**
 * [tOracleConnection_1 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleConnection_1_SUBPROCESS_STATE", 1);
	}
	

public void tSCPConnection_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tSCPConnection_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tSCPConnection_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tSCPConnection_1", false);
		start_Hash.put("tSCPConnection_1", System.currentTimeMillis());
		
	
	currentComponent="tSCPConnection_1";

	
		int tos_count_tSCPConnection_1 = 0;
		
    	class BytesLimit65535_tSCPConnection_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tSCPConnection_1().limitLog4jByte();

 	
	String hostname_tSCPConnection_1 = context.sigb_biu_host;
    String username_tSCPConnection_1 = context.sigb_biu_username;
    /* Create a connection instance */
			ch.ethz.ssh2.Connection conn_tSCPConnection_1 = new ch.ethz.ssh2.Connection(hostname_tSCPConnection_1,context.sigb_biu_port);
              /* Now connect */
		
        conn_tSCPConnection_1.connect();
		
			
        	java.io.File keyfile_tSCPConnection_1 = new java.io.File(context.sigb_biu_cle_publique); 
        	
            
	final String decryptedPassword_tSCPConnection_1 = context.sigb_biu_password; 
        	
            boolean isAuthenticated_tSCPConnection_1 = conn_tSCPConnection_1.authenticateWithPublicKey(username_tSCPConnection_1, keyfile_tSCPConnection_1, decryptedPassword_tSCPConnection_1);
			if (isAuthenticated_tSCPConnection_1 == false){
                throw new RuntimeException("Authentication failed.");
			}
			
		globalMap.put("conn_tSCPConnection_1",conn_tSCPConnection_1);

 



/**
 * [tSCPConnection_1 begin ] stop
 */
	
	/**
	 * [tSCPConnection_1 main ] start
	 */

	

	
	
	currentComponent="tSCPConnection_1";

	

 


	tos_count_tSCPConnection_1++;

/**
 * [tSCPConnection_1 main ] stop
 */
	
	/**
	 * [tSCPConnection_1 end ] start
	 */

	

	
	
	currentComponent="tSCPConnection_1";

	

 

ok_Hash.put("tSCPConnection_1", true);
end_Hash.put("tSCPConnection_1", System.currentTimeMillis());




/**
 * [tSCPConnection_1 end ] stop
 */
				}//end the resume

				
				    			if(resumeEntryMethodName == null || globalResumeTicket){
				    				resumeUtil.addLog("CHECKPOINT", "CONNECTION:SUBJOB_OK:tSCPConnection_1:OnSubjobOk", "", Thread.currentThread().getId() + "", "", "", "", "", "");
								}	    				    			
					    	
								if(execStat){    	
									runStat.updateStatOnConnection("OnSubjobOk1", 0, "ok");
								} 
							
							tOracleInput_1Process(globalMap); 
						



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tSCPConnection_1 finally ] start
	 */

	

	
	
	currentComponent="tSCPConnection_1";

	

 



/**
 * [tSCPConnection_1 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tSCPConnection_1_SUBPROCESS_STATE", 1);
	}
	


public static class xmlStruct implements routines.system.IPersistableRow<xmlStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public routines.system.Document doc;

				public routines.system.Document getDoc () {
					return this.doc;
				}
				



    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
						this.doc = (routines.system.Document) dis.readObject();
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		
			} catch(ClassNotFoundException eCNFE) {
				 throw new RuntimeException(eCNFE);
		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// Document
				
       			    	dos.writeObject(this.doc);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("doc="+String.valueOf(doc));
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(xmlStruct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class infogeneStruct implements routines.system.IPersistableRow<infogeneStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String NOM;

				public String getNOM () {
					return this.NOM;
				}
				
			    public String PRENOM;

				public String getPRENOM () {
					return this.PRENOM;
				}
				
			    public String GROUPE;

				public String getGROUPE () {
					return this.GROUPE;
				}
				
			    public String CAMPUS;

				public String getCAMPUS () {
					return this.CAMPUS;
				}
				
			    public String LANGUE;

				public String getLANGUE () {
					return this.LANGUE;
				}
				
			    public String STATUT;

				public String getSTATUT () {
					return this.STATUT;
				}
				
			    public java.util.Date DATE_NAISSANCE;

				public java.util.Date getDATE_NAISSANCE () {
					return this.DATE_NAISSANCE;
				}
				
			    public java.util.Date DATE_MODIF;

				public java.util.Date getDATE_MODIF () {
					return this.DATE_MODIF;
				}
				
			    public java.util.Date DATE_EXPIRATION;

				public java.util.Date getDATE_EXPIRATION () {
					return this.DATE_EXPIRATION;
				}
				
			    public java.util.Date DATE_ELIMINATION;

				public java.util.Date getDATE_ELIMINATION () {
					return this.DATE_ELIMINATION;
				}
				
			    public String EPPN;

				public String getEPPN () {
					return this.EPPN;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private java.util.Date readDate(ObjectInputStream dis) throws IOException{
		java.util.Date dateReturn = null;
        int length = 0;
        length = dis.readByte();
		if (length == -1) {
			dateReturn = null;
		} else {
	    	dateReturn = new Date(dis.readLong());
		}
		return dateReturn;
	}

    private void writeDate(java.util.Date date1, ObjectOutputStream dos) throws IOException{
		if(date1 == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeLong(date1.getTime());
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
					this.NOM = readString(dis);
					
					this.PRENOM = readString(dis);
					
					this.GROUPE = readString(dis);
					
					this.CAMPUS = readString(dis);
					
					this.LANGUE = readString(dis);
					
					this.STATUT = readString(dis);
					
					this.DATE_NAISSANCE = readDate(dis);
					
					this.DATE_MODIF = readDate(dis);
					
					this.DATE_EXPIRATION = readDate(dis);
					
					this.DATE_ELIMINATION = readDate(dis);
					
					this.EPPN = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
					// String
				
						writeString(this.NOM,dos);
					
					// String
				
						writeString(this.PRENOM,dos);
					
					// String
				
						writeString(this.GROUPE,dos);
					
					// String
				
						writeString(this.CAMPUS,dos);
					
					// String
				
						writeString(this.LANGUE,dos);
					
					// String
				
						writeString(this.STATUT,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_NAISSANCE,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_MODIF,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_EXPIRATION,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_ELIMINATION,dos);
					
					// String
				
						writeString(this.EPPN,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",NOM="+NOM);
		sb.append(",PRENOM="+PRENOM);
		sb.append(",GROUPE="+GROUPE);
		sb.append(",CAMPUS="+CAMPUS);
		sb.append(",LANGUE="+LANGUE);
		sb.append(",STATUT="+STATUT);
		sb.append(",DATE_NAISSANCE="+String.valueOf(DATE_NAISSANCE));
		sb.append(",DATE_MODIF="+String.valueOf(DATE_MODIF));
		sb.append(",DATE_EXPIRATION="+String.valueOf(DATE_EXPIRATION));
		sb.append(",DATE_ELIMINATION="+String.valueOf(DATE_ELIMINATION));
		sb.append(",EPPN="+EPPN);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(infogeneStruct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}

public static class after_tOracleInput_1Struct implements routines.system.IPersistableRow<after_tOracleInput_1Struct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String NOM;

				public String getNOM () {
					return this.NOM;
				}
				
			    public String PRENOM;

				public String getPRENOM () {
					return this.PRENOM;
				}
				
			    public String GROUPE;

				public String getGROUPE () {
					return this.GROUPE;
				}
				
			    public String CAMPUS;

				public String getCAMPUS () {
					return this.CAMPUS;
				}
				
			    public String LANGUE;

				public String getLANGUE () {
					return this.LANGUE;
				}
				
			    public String STATUT;

				public String getSTATUT () {
					return this.STATUT;
				}
				
			    public java.util.Date DATE_NAISSANCE;

				public java.util.Date getDATE_NAISSANCE () {
					return this.DATE_NAISSANCE;
				}
				
			    public java.util.Date DATE_MODIF;

				public java.util.Date getDATE_MODIF () {
					return this.DATE_MODIF;
				}
				
			    public java.util.Date DATE_EXPIRATION;

				public java.util.Date getDATE_EXPIRATION () {
					return this.DATE_EXPIRATION;
				}
				
			    public java.util.Date DATE_ELIMINATION;

				public java.util.Date getDATE_ELIMINATION () {
					return this.DATE_ELIMINATION;
				}
				
			    public String EPPN;

				public String getEPPN () {
					return this.EPPN;
				}
				



	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private java.util.Date readDate(ObjectInputStream dis) throws IOException{
		java.util.Date dateReturn = null;
        int length = 0;
        length = dis.readByte();
		if (length == -1) {
			dateReturn = null;
		} else {
	    	dateReturn = new Date(dis.readLong());
		}
		return dateReturn;
	}

    private void writeDate(java.util.Date date1, ObjectOutputStream dos) throws IOException{
		if(date1 == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeLong(date1.getTime());
    	}
    }

    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
					this.NOM = readString(dis);
					
					this.PRENOM = readString(dis);
					
					this.GROUPE = readString(dis);
					
					this.CAMPUS = readString(dis);
					
					this.LANGUE = readString(dis);
					
					this.STATUT = readString(dis);
					
					this.DATE_NAISSANCE = readDate(dis);
					
					this.DATE_MODIF = readDate(dis);
					
					this.DATE_EXPIRATION = readDate(dis);
					
					this.DATE_ELIMINATION = readDate(dis);
					
					this.EPPN = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
					// String
				
						writeString(this.NOM,dos);
					
					// String
				
						writeString(this.PRENOM,dos);
					
					// String
				
						writeString(this.GROUPE,dos);
					
					// String
				
						writeString(this.CAMPUS,dos);
					
					// String
				
						writeString(this.LANGUE,dos);
					
					// String
				
						writeString(this.STATUT,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_NAISSANCE,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_MODIF,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_EXPIRATION,dos);
					
					// java.util.Date
				
						writeDate(this.DATE_ELIMINATION,dos);
					
					// String
				
						writeString(this.EPPN,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",NOM="+NOM);
		sb.append(",PRENOM="+PRENOM);
		sb.append(",GROUPE="+GROUPE);
		sb.append(",CAMPUS="+CAMPUS);
		sb.append(",LANGUE="+LANGUE);
		sb.append(",STATUT="+STATUT);
		sb.append(",DATE_NAISSANCE="+String.valueOf(DATE_NAISSANCE));
		sb.append(",DATE_MODIF="+String.valueOf(DATE_MODIF));
		sb.append(",DATE_EXPIRATION="+String.valueOf(DATE_EXPIRATION));
		sb.append(",DATE_ELIMINATION="+String.valueOf(DATE_ELIMINATION));
		sb.append(",EPPN="+EPPN);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(after_tOracleInput_1Struct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tOracleInput_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleInput_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
		String currentVirtualComponent = null;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;


		tOracleInput_2Process(globalMap);
		tOracleInput_3Process(globalMap);
		tOracleInput_4Process(globalMap);
		tOracleInput_5Process(globalMap);

		infogeneStruct infogene = new infogeneStruct();
xmlStruct xml = new xmlStruct();




	
	/**
	 * [tXMLMap_1_TXMLMAP_OUT begin ] start
	 */

	

	
		
		ok_Hash.put("tXMLMap_1_TXMLMAP_OUT", false);
		start_Hash.put("tXMLMap_1_TXMLMAP_OUT", System.currentTimeMillis());
		
	
		currentVirtualComponent = "tXMLMap_1";
	
	currentComponent="tXMLMap_1_TXMLMAP_OUT";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("infogene" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tXMLMap_1_TXMLMAP_OUT = 0;
		
    	class BytesLimit65535_tXMLMap_1_TXMLMAP_OUT{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tXMLMap_1_TXMLMAP_OUT().limitLog4jByte();

	org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<mailStruct> tHash_Lookup_mail = (org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<mailStruct>) 
			((org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<mailStruct>) 
				globalMap.get( "tHash_Lookup_mail" ))
				;
	
	
	mailStruct mailHashKey = new mailStruct();
	mailStruct mailDefault = new mailStruct();
	mailStruct mail = new mailStruct();
	
	org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<adresseStruct> tHash_Lookup_adresse = (org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<adresseStruct>) 
			((org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<adresseStruct>) 
				globalMap.get( "tHash_Lookup_adresse" ))
				;
	
	
	adresseStruct adresseHashKey = new adresseStruct();
	adresseStruct adresseDefault = new adresseStruct();
	adresseStruct adresse = new adresseStruct();
	
	org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<telephoneStruct> tHash_Lookup_telephone = (org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<telephoneStruct>) 
			((org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<telephoneStruct>) 
				globalMap.get( "tHash_Lookup_telephone" ))
				;
	
	
	telephoneStruct telephoneHashKey = new telephoneStruct();
	telephoneStruct telephoneDefault = new telephoneStruct();
	telephoneStruct telephone = new telephoneStruct();
	
	org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<statistiquesStruct> tHash_Lookup_statistiques = (org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<statistiquesStruct>) 
			((org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<statistiquesStruct>) 
				globalMap.get( "tHash_Lookup_statistiques" ))
				;
	
	
	statistiquesStruct statistiquesHashKey = new statistiquesStruct();
	statistiquesStruct statistiquesDefault = new statistiquesStruct();
	statistiquesStruct statistiques = new statistiquesStruct();
	
	
	
//===============================input xml init part===============================
class XML_API_tXMLMap_1_TXMLMAP_OUT{
	public boolean isDefNull(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null && node instanceof org.dom4j.Element) {
        	org.dom4j.Attribute attri = ((org.dom4j.Element)node).attribute("nil");
        	if(attri != null && ("true").equals(attri.getText())){
            	return true;
            }
        }
        return false;
    }

    public boolean isMissing(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        return node == null ? true : false;
    }

    public boolean isEmpty(org.dom4j.Node node) throws javax.xml.transform.TransformerException {
        if (node != null) {
            return node.getText().length() == 0;
        }
        return false;
    }
}
	class Var__tXMLMap_1_TXMLMAP_OUT__Struct {	String fullname;
	}
	Var__tXMLMap_1_TXMLMAP_OUT__Struct Var__tXMLMap_1_TXMLMAP_OUT = new Var__tXMLMap_1_TXMLMAP_OUT__Struct();
// ###############################
// # Outputs initialization
xmlStruct xml_tmp = new xmlStruct();
xmlStruct xml_save = null;
//the aggregate variable
xmlStruct xml_aggregate = null;
//init the resultset for aggregate
java.util.List<Object> allOutsForAggregate_tXMLMap_1 = new java.util.ArrayList<Object>();
globalMap.put("allOutsForAggregate_tXMLMap_1",allOutsForAggregate_tXMLMap_1);
// ###############################
		int nb_line_tXMLMap_1_TXMLMAP_OUT = 0; 
	
    XML_API_tXMLMap_1_TXMLMAP_OUT xml_api_tXMLMap_1_TXMLMAP_OUT = new XML_API_tXMLMap_1_TXMLMAP_OUT();

	//the map store the previous value of aggregate columns
	java.util.Map<String,Object> aggregateCacheMap_tXMLMap_1_TXMLMAP_OUT = new java.util.HashMap<String,Object>();

class GenerateDocument_xml {

	java.util.Map<String,Object> valueMap = null;
	
	routines.system.DocumentGenerateOrderHelper orderHelper = new routines.system.DocumentGenerateOrderHelper(2);
	
	org.dom4j.Document doc = null;
	
	org.dom4j.Element root4Group = null;
	
	org.dom4j.io.OutputFormat format = null;
	
	java.util.List<java.util.List<String>> groupbyList = null;
	java.util.List<org.dom4j.Element> groupElementList = null;
	int order = 0;
	
	boolean isFirst = true;
	
	boolean	needRoot = true;
	
	String currentValue = null;

		org.dom4j.Element subTreeLoopParent0 = null;
		public boolean  subTreeLoop0 = false;
	
    public GenerateDocument_xml() {
//    	this.treeNodeAPI = treeNodeAPI;
    	
    	valueMap = new java.util.HashMap<String,Object>();
    	
    	groupbyList =  new java.util.ArrayList<java.util.List<String>>();
		groupElementList = new java.util.ArrayList<org.dom4j.Element>();
    	
    	doc = org.dom4j.DocumentHelper.createDocument();
    	format = org.dom4j.io.OutputFormat.createPrettyPrint();
    	format.setTrimText(false);
    }
    
    public org.dom4j.Document getDocument(){
    	return this.doc;
    }
    
	//We generate the TreeNode_API object only if there is a document in the main input table.
    void generateElements(boolean isInnerJoin, infogeneStruct infogene, mailStruct mail, adresseStruct adresse, telephoneStruct telephone, statistiquesStruct statistiques, Var__tXMLMap_1_TXMLMAP_OUT__Struct Var
	) {
	
	
	/*if(this.treeNodeAPI==null) {
		this.treeNodeAPI = treeNodeAPI;
	}*/
	
	org.dom4j.Element subTreeRootParent = null;
// build root xml tree 
if (needRoot) {
	needRoot=false;
		org.dom4j.Element root = null;
				root = doc.addElement("users");
		subTreeRootParent = root;
		root4Group = subTreeRootParent;
	}else{
		subTreeRootParent=root4Group;
	}
	/* build group xml tree */
	boolean isNewElement = false;
			isNewElement = false;
					if(isNewElement || groupbyList.size()<=0 || groupbyList.get(0)==null
					|| ( groupbyList.get(0).get(0)!=null ? !groupbyList.get(0).get(0).equals(FormatterUtils.format(infogene.CODE_BARRE,null)) : FormatterUtils.format(infogene.CODE_BARRE,null)!=null )
					|| ( groupbyList.get(0).get(1)!=null ? !groupbyList.get(0).get(1).equals(FormatterUtils.format(infogene.PRENOM,null)) : FormatterUtils.format(infogene.PRENOM,null)!=null )
					|| ( groupbyList.get(0).get(2)!=null ? !groupbyList.get(0).get(2).equals(FormatterUtils.format(infogene.NOM,null)) : FormatterUtils.format(infogene.NOM,null)!=null )
					|| ( groupbyList.get(0).get(3)!=null ? !groupbyList.get(0).get(3).equals(FormatterUtils.format(Var.fullname,null)) : FormatterUtils.format(Var.fullname,null)!=null )
					|| ( groupbyList.get(0).get(4)!=null ? !groupbyList.get(0).get(4).equals(FormatterUtils.format(context.sigb_user_group_desc,null)) : FormatterUtils.format(context.sigb_user_group_desc,null)!=null )
					|| ( groupbyList.get(0).get(5)!=null ? !groupbyList.get(0).get(5).equals(FormatterUtils.format(context.sigb_cataloger_level_desc,null)) : FormatterUtils.format(context.sigb_cataloger_level_desc,null)!=null )
					|| ( groupbyList.get(0).get(6)!=null ? !groupbyList.get(0).get(6).equals(FormatterUtils.format( infogene.LANGUE,null)) : FormatterUtils.format( infogene.LANGUE,null)!=null )
					|| ( groupbyList.get(0).get(7)!=null ? !groupbyList.get(0).get(7).equals(FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_NAISSANCE) ,"dd-MM-yyyy")) : FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_NAISSANCE) ,"dd-MM-yyyy")!=null )
					|| ( groupbyList.get(0).get(8)!=null ? !groupbyList.get(0).get(8).equals(FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_EXPIRATION) ,"dd-MM-yyyy")) : FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_EXPIRATION) ,"dd-MM-yyyy")!=null )
					|| ( groupbyList.get(0).get(9)!=null ? !groupbyList.get(0).get(9).equals(FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_ELIMINATION) ,"dd-MM-yyyy")) : FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_ELIMINATION) ,"dd-MM-yyyy")!=null )
					|| ( groupbyList.get(0).get(10)!=null ? !groupbyList.get(0).get(10).equals(FormatterUtils.format(context.sigb_external_desc,null)) : FormatterUtils.format(context.sigb_external_desc,null)!=null )
					|| ( groupbyList.get(0).get(11)!=null ? !groupbyList.get(0).get(11).equals(FormatterUtils.format(context.sigb_external_id,null)) : FormatterUtils.format(context.sigb_external_id,null)!=null )
					|| ( groupbyList.get(0).get(12)!=null ? !groupbyList.get(0).get(12).equals(FormatterUtils.format(context.sigb_active,null)) : FormatterUtils.format(context.sigb_active,null)!=null )
					|| ( groupbyList.get(0).get(13)!=null ? !groupbyList.get(0).get(13).equals(FormatterUtils.format(infogene.EPPN,null)) : FormatterUtils.format(infogene.EPPN,null)!=null )
					|| ( groupbyList.get(0).get(14)!=null ? !groupbyList.get(0).get(14).equals(FormatterUtils.format(context.sigb_active,null)) : FormatterUtils.format(context.sigb_active,null)!=null )
					){

		org.dom4j.Element group0_ = null;
				group0_ = org.dom4j.DocumentHelper.createElement("user");
				subTreeRootParent.elements().add(orderHelper.getInsertLocation(0,0),group0_);
		subTreeRootParent = group0_;
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0_,  null , "link", currentValue);
		org.dom4j.Element group0__1 = null;
				group0__1 = group0_.addElement("record_type");
		valueMap.put("group0__1",context.sigb_record_type);
		if(valueMap.get("group0__1")!=null) {
			routines.system.NestXMLTool.setText(group0__1, FormatterUtils.format(context.sigb_record_type,null));
		}
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__1,  null , "desc", currentValue);
		org.dom4j.Element group0__3 = null;
				group0__3 = group0_.addElement("primary_id");
		valueMap.put("group0__3",infogene.CODE_BARRE);
		if(valueMap.get("group0__3")!=null) {
			routines.system.NestXMLTool.setText(group0__3, FormatterUtils.format(infogene.CODE_BARRE,null));
		}
		org.dom4j.Element group0__4 = null;
				group0__4 = group0_.addElement("first_name");
		valueMap.put("group0__4",infogene.PRENOM);
		if(valueMap.get("group0__4")!=null) {
			routines.system.NestXMLTool.setText(group0__4, FormatterUtils.format(infogene.PRENOM,null));
		}
		org.dom4j.Element group0__5 = null;
				group0__5 = group0_.addElement("middle_name");
		org.dom4j.Element group0__6 = null;
				group0__6 = group0_.addElement("last_name");
		valueMap.put("group0__6",infogene.NOM);
		if(valueMap.get("group0__6")!=null) {
			routines.system.NestXMLTool.setText(group0__6, FormatterUtils.format(infogene.NOM,null));
		}
		org.dom4j.Element group0__7 = null;
				group0__7 = group0_.addElement("full_name");
		valueMap.put("group0__7",Var.fullname);
		if(valueMap.get("group0__7")!=null) {
			routines.system.NestXMLTool.setText(group0__7, FormatterUtils.format(Var.fullname,null));
		}
		org.dom4j.Element group0__8 = null;
				group0__8 = group0_.addElement("pin_number");
		org.dom4j.Element group0__9 = null;
				group0__9 = group0_.addElement("user_title");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__9,  null , "desc", currentValue);
		org.dom4j.Element group0__11 = null;
				group0__11 = group0_.addElement("job_category");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__11,  null , "desc", currentValue);
		org.dom4j.Element group0__13 = null;
				group0__13 = group0_.addElement("job_description");
		org.dom4j.Element group0__14 = null;
				group0__14 = group0_.addElement("gender");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__14,  null , "desc", currentValue);
		org.dom4j.Element group0__16 = null;
				group0__16 = group0_.addElement("user_group");
		valueMap.put("group0__16",context.sigb_user_group);
		if(valueMap.get("group0__16")!=null) {
			routines.system.NestXMLTool.setText(group0__16, FormatterUtils.format(context.sigb_user_group,null));
		}
				currentValue = null;
    			valueMap.put("group0__16",context.sigb_user_group_desc);
    			if(valueMap.get("group0__16")!=null) {
    				currentValue = FormatterUtils.format(context.sigb_user_group_desc,null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__16,  null , "desc", currentValue);
		org.dom4j.Element group0__18 = null;
				group0__18 = group0_.addElement("campus_code");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__18,  null , "desc", currentValue);
		org.dom4j.Element group0__20 = null;
				group0__20 = group0_.addElement("web_site_url");
		org.dom4j.Element group0__21 = null;
				group0__21 = group0_.addElement("cataloger_level");
		valueMap.put("group0__21",context.sigb_cataloger_level);
		if(valueMap.get("group0__21")!=null) {
			routines.system.NestXMLTool.setText(group0__21, FormatterUtils.format(context.sigb_cataloger_level,null));
		}
				currentValue = null;
    			valueMap.put("group0__21",context.sigb_cataloger_level_desc);
    			if(valueMap.get("group0__21")!=null) {
    				currentValue = FormatterUtils.format(context.sigb_cataloger_level_desc,null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__21,  null , "desc", currentValue);
		org.dom4j.Element group0__23 = null;
				group0__23 = group0_.addElement("preferred_language");
		valueMap.put("group0__23", infogene.LANGUE);
		if(valueMap.get("group0__23")!=null) {
			routines.system.NestXMLTool.setText(group0__23, FormatterUtils.format( infogene.LANGUE,null));
		}
		org.dom4j.Element group0__24 = null;
				group0__24 = group0_.addElement("birth_date");
		valueMap.put("group0__24",TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_NAISSANCE) );
		if(valueMap.get("group0__24")!=null) {
			routines.system.NestXMLTool.setText(group0__24, FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_NAISSANCE) ,"dd-MM-yyyy"));
		}
		org.dom4j.Element group0__25 = null;
				group0__25 = group0_.addElement("expiry_date");
		valueMap.put("group0__25",TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_EXPIRATION) );
		if(valueMap.get("group0__25")!=null) {
			routines.system.NestXMLTool.setText(group0__25, FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_EXPIRATION) ,"dd-MM-yyyy"));
		}
		org.dom4j.Element group0__26 = null;
				group0__26 = group0_.addElement("purge_date");
		valueMap.put("group0__26",TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_ELIMINATION) );
		if(valueMap.get("group0__26")!=null) {
			routines.system.NestXMLTool.setText(group0__26, FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_ELIMINATION) ,"dd-MM-yyyy"));
		}
		org.dom4j.Element group0__27 = null;
				group0__27 = group0_.addElement("account_type");
		valueMap.put("group0__27",context.sigb_external);
		if(valueMap.get("group0__27")!=null) {
			routines.system.NestXMLTool.setText(group0__27, FormatterUtils.format(context.sigb_external,null));
		}
				currentValue = null;
    			valueMap.put("group0__27",context.sigb_external_desc);
    			if(valueMap.get("group0__27")!=null) {
    				currentValue = FormatterUtils.format(context.sigb_external_desc,null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__27,  null , "desc", currentValue);
		org.dom4j.Element group0__29 = null;
				group0__29 = group0_.addElement("external_id");
		valueMap.put("group0__29",context.sigb_external_id);
		if(valueMap.get("group0__29")!=null) {
			routines.system.NestXMLTool.setText(group0__29, FormatterUtils.format(context.sigb_external_id,null));
		}
		org.dom4j.Element group0__30 = null;
				group0__30 = group0_.addElement("password");
		org.dom4j.Element group0__31 = null;
				group0__31 = group0_.addElement("force_password_change");
		org.dom4j.Element group0__32 = null;
				group0__32 = group0_.addElement("status");
		valueMap.put("group0__32",context.sigb_active);
		if(valueMap.get("group0__32")!=null) {
			routines.system.NestXMLTool.setText(group0__32, FormatterUtils.format(context.sigb_active,null));
		}
				currentValue = null;
    			valueMap.put("group0__32",context.sigb_active);
    			if(valueMap.get("group0__32")!=null) {
    				currentValue = FormatterUtils.format(context.sigb_active,null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__32,  null , "desc", currentValue);
					subTreeLoopParent0 = group0_;
		org.dom4j.Element group0__34 = null;
				group0__34 = group0_.addElement("user_identifiers");
		org.dom4j.Element group0__34_35 = null;
				group0__34_35 = group0__34.addElement("user_identifier");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__34_35,  null , "segment_type", currentValue);
		org.dom4j.Element group0__34_35_37 = null;
				group0__34_35_37 = group0__34_35.addElement("id_type");
		valueMap.put("group0__34_35_37",context.sigb_id_type_eppn);
		if(valueMap.get("group0__34_35_37")!=null) {
			routines.system.NestXMLTool.setText(group0__34_35_37, FormatterUtils.format(context.sigb_id_type_eppn,null));
		}
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__34_35_37,  null , "desc", currentValue);
		org.dom4j.Element group0__34_35_39 = null;
				group0__34_35_39 = group0__34_35.addElement("value");
		valueMap.put("group0__34_35_39",infogene.EPPN);
		if(valueMap.get("group0__34_35_39")!=null) {
			routines.system.NestXMLTool.setText(group0__34_35_39, FormatterUtils.format(infogene.EPPN,null));
		}
		org.dom4j.Element group0__34_35_40 = null;
				group0__34_35_40 = group0__34_35.addElement("note");
		org.dom4j.Element group0__34_35_41 = null;
				group0__34_35_41 = group0__34_35.addElement("status");
		valueMap.put("group0__34_35_41",context.sigb_active);
		if(valueMap.get("group0__34_35_41")!=null) {
			routines.system.NestXMLTool.setText(group0__34_35_41, FormatterUtils.format(context.sigb_active,null));
		}
		org.dom4j.Element group0__42 = null;
				group0__42 = group0_.addElement("user_roles");
		org.dom4j.Element group0__42_43 = null;
				group0__42_43 = group0__42.addElement("user_role");
		org.dom4j.Element group0__42_43_44 = null;
				group0__42_43_44 = group0__42_43.addElement("status");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__42_43_44,  null , "desc", currentValue);
		org.dom4j.Element group0__42_43_46 = null;
				group0__42_43_46 = group0__42_43.addElement("scope");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__42_43_46,  null , "desc", currentValue);
		org.dom4j.Element group0__42_43_48 = null;
				group0__42_43_48 = group0__42_43.addElement("role_type");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__42_43_48,  null , "desc", currentValue);
		org.dom4j.Element group0__42_43_50 = null;
				group0__42_43_50 = group0__42_43.addElement("parameters");
		org.dom4j.Element group0__42_43_50_51 = null;
				group0__42_43_50_51 = group0__42_43_50.addElement("parameter");
		org.dom4j.Element group0__42_43_50_51_52 = null;
				group0__42_43_50_51_52 = group0__42_43_50_51.addElement("type");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__42_43_50_51_52,  null , "desc", currentValue);
		org.dom4j.Element group0__42_43_50_51_54 = null;
				group0__42_43_50_51_54 = group0__42_43_50_51.addElement("value");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__42_43_50_51_54,  null , "desc", currentValue);
		org.dom4j.Element group0__56 = null;
				group0__56 = group0_.addElement("user_blocks");
		org.dom4j.Element group0__57 = null;
				group0__57 = group0_.addElement("user_notes");
		org.dom4j.Element group0__57_58 = null;
				group0__57_58 = group0__57.addElement("user_note");
		org.dom4j.Element group0__59 = null;
				group0__59 = group0_.addElement("user_statistics");
		org.dom4j.Element group0__59_60 = null;
				group0__59_60 = group0__59.addElement("user_statistic");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__59_60,  null , "segment_type", currentValue);
		org.dom4j.Element group0__59_60_62 = null;
				group0__59_60_62 = group0__59_60.addElement("statistic_category");
		valueMap.put("group0__59_60_62",(statistiques.CATEGORIE != null && !statistiques.CATEGORIE.equals(""))?statistiques.CATEGORIE:null );
		if(valueMap.get("group0__59_60_62")!=null) {
			routines.system.NestXMLTool.setText(group0__59_60_62, FormatterUtils.format((statistiques.CATEGORIE != null && !statistiques.CATEGORIE.equals(""))?statistiques.CATEGORIE:null ,null));
		}
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__59_60_62,  null , "desc", currentValue);
		org.dom4j.Element group0__59_60_64 = null;
				group0__59_60_64 = group0__59_60.addElement("category_type");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__59_60_64,  null , "desc", currentValue);
		org.dom4j.Element group0__59_60_66 = null;
				group0__59_60_66 = group0__59_60.addElement("statistic_note");
		org.dom4j.Element group0__67 = null;
				group0__67 = group0_.addElement("proxy_for_users");
		org.dom4j.Element group0__67_68 = null;
				group0__67_68 = group0__67.addElement("proxy_for_user");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__67_68,  null , "link", currentValue);
		org.dom4j.Element group0__67_68_70 = null;
				group0__67_68_70 = group0__67_68.addElement("primary_id");
		org.dom4j.Element group0__67_68_71 = null;
				group0__67_68_71 = group0__67_68.addElement("full_name");
		org.dom4j.Element group0__72 = null;
				group0__72 = group0_.addElement("rs_libraries");
		org.dom4j.Element group0__72_73 = null;
				group0__72_73 = group0__72.addElement("rs_library");
		org.dom4j.Element group0__72_73_74 = null;
				group0__72_73_74 = group0__72_73.addElement("code");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__72_73_74,  null , "desc", currentValue);
		org.dom4j.Element group0__76 = null;
				group0__76 = group0_.addElement("library_notices");
		org.dom4j.Element group0__76_77 = null;
				group0__76_77 = group0__76.addElement("library_notice");
		org.dom4j.Element group0__76_77_78 = null;
				group0__76_77_78 = group0__76_77.addElement("code");
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(group0__76_77_78,  null , "desc", currentValue);
		org.dom4j.Element group0__80 = null;
				group0__80 = group0_.addElement("source_link_id");
		org.dom4j.Element group0__81 = null;
				group0__81 = group0_.addElement("source_institution_code");
		org.dom4j.Element group0__82 = null;
				group0__82 = group0_.addElement("linking_id");	
					if(groupbyList.size()<=0){
						groupbyList.add(new java.util.ArrayList<String>());
					}else{
						groupbyList.get(0).clear();
					}
						groupbyList.get(0).add(FormatterUtils.format(infogene.CODE_BARRE,null));
						groupbyList.get(0).add(FormatterUtils.format(infogene.PRENOM,null));
						groupbyList.get(0).add(FormatterUtils.format(infogene.NOM,null));
						groupbyList.get(0).add(FormatterUtils.format(Var.fullname,null));
						groupbyList.get(0).add(FormatterUtils.format(context.sigb_user_group_desc,null));
						groupbyList.get(0).add(FormatterUtils.format(context.sigb_cataloger_level_desc,null));
						groupbyList.get(0).add(FormatterUtils.format( infogene.LANGUE,null));
						groupbyList.get(0).add(FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_NAISSANCE) ,"dd-MM-yyyy"));
						groupbyList.get(0).add(FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_EXPIRATION) ,"dd-MM-yyyy"));
						groupbyList.get(0).add(FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'", infogene.DATE_ELIMINATION) ,"dd-MM-yyyy"));
						groupbyList.get(0).add(FormatterUtils.format(context.sigb_external_desc,null));
						groupbyList.get(0).add(FormatterUtils.format(context.sigb_external_id,null));
						groupbyList.get(0).add(FormatterUtils.format(context.sigb_active,null));
						groupbyList.get(0).add(FormatterUtils.format(infogene.EPPN,null));
						groupbyList.get(0).add(FormatterUtils.format(context.sigb_active,null));
					isNewElement=true;
					if(groupElementList.size()<=0){
						groupElementList.add(group0_);
					}else{
						groupElementList.set(0,group0_);
					}
			
				}else{
					subTreeRootParent=groupElementList.get(0);
				}

			
		isNewElement = false;
		org.dom4j.Element loop = null;
				loop = org.dom4j.DocumentHelper.createElement("contact_info");
				subTreeRootParent.elements().add(orderHelper.getInsertLocation(1,24),loop);
		subTreeRootParent = loop;
		org.dom4j.Element loop_83 = null;
				loop_83 = loop.addElement("addresses");
		org.dom4j.Element loop_83_84 = null;
				loop_83_84 = loop_83.addElement("address");
				currentValue = null;
    			valueMap.put("loop_83_84",(adresse.TYPE.equals("work"))?"true":"false");
    			if(valueMap.get("loop_83_84")!=null) {
    				currentValue = FormatterUtils.format((adresse.TYPE.equals("work"))?"true":"false",null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_83_84,  null , "preferred", currentValue);
				currentValue = null;
    			valueMap.put("loop_83_84",context.sigb_external_desc);
    			if(valueMap.get("loop_83_84")!=null) {
    				currentValue = FormatterUtils.format(context.sigb_external_desc,null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_83_84,  null , "segment_type", currentValue);
		org.dom4j.Element loop_83_84_87 = null;
				loop_83_84_87 = loop_83_84.addElement("line1");
		valueMap.put("loop_83_84_87",adresse.ADR1);
		if(valueMap.get("loop_83_84_87")!=null) {
			routines.system.NestXMLTool.setText(loop_83_84_87, FormatterUtils.format(adresse.ADR1,null));
		}
		org.dom4j.Element loop_83_84_88 = null;
				loop_83_84_88 = loop_83_84.addElement("line2");
		valueMap.put("loop_83_84_88",adresse.ADR2);
		if(valueMap.get("loop_83_84_88")!=null) {
			routines.system.NestXMLTool.setText(loop_83_84_88, FormatterUtils.format(adresse.ADR2,null));
		}
		org.dom4j.Element loop_83_84_89 = null;
				loop_83_84_89 = loop_83_84.addElement("line3");
		valueMap.put("loop_83_84_89",adresse.ADR3);
		if(valueMap.get("loop_83_84_89")!=null) {
			routines.system.NestXMLTool.setText(loop_83_84_89, FormatterUtils.format(adresse.ADR3,null));
		}
		org.dom4j.Element loop_83_84_90 = null;
				loop_83_84_90 = loop_83_84.addElement("line4");
		valueMap.put("loop_83_84_90",adresse.ADR4);
		if(valueMap.get("loop_83_84_90")!=null) {
			routines.system.NestXMLTool.setText(loop_83_84_90, FormatterUtils.format(adresse.ADR4,null));
		}
		org.dom4j.Element loop_83_84_91 = null;
				loop_83_84_91 = loop_83_84.addElement("line5");
		valueMap.put("loop_83_84_91",adresse.ADR5);
		if(valueMap.get("loop_83_84_91")!=null) {
			routines.system.NestXMLTool.setText(loop_83_84_91, FormatterUtils.format(adresse.ADR5,null));
		}
		org.dom4j.Element loop_83_84_92 = null;
				loop_83_84_92 = loop_83_84.addElement("city");
		valueMap.put("loop_83_84_92",adresse.VILLE);
		if(valueMap.get("loop_83_84_92")!=null) {
			routines.system.NestXMLTool.setText(loop_83_84_92, FormatterUtils.format(adresse.VILLE,null));
		}
		org.dom4j.Element loop_83_84_93 = null;
				loop_83_84_93 = loop_83_84.addElement("state_province");
		org.dom4j.Element loop_83_84_94 = null;
				loop_83_84_94 = loop_83_84.addElement("postal_code");
		valueMap.put("loop_83_84_94",adresse.CP);
		if(valueMap.get("loop_83_84_94")!=null) {
			routines.system.NestXMLTool.setText(loop_83_84_94, FormatterUtils.format(adresse.CP,null));
		}
		org.dom4j.Element loop_83_84_95 = null;
				loop_83_84_95 = loop_83_84.addElement("country");
		valueMap.put("loop_83_84_95",adresse.PAYS );
		if(valueMap.get("loop_83_84_95")!=null) {
			routines.system.NestXMLTool.setText(loop_83_84_95, FormatterUtils.format(adresse.PAYS ,null));
		}
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_83_84_95,  null , "desc", currentValue);
		org.dom4j.Element loop_83_84_97 = null;
				loop_83_84_97 = loop_83_84.addElement("address_note");
		org.dom4j.Element loop_83_84_98 = null;
				loop_83_84_98 = loop_83_84.addElement("start_date");
		valueMap.put("loop_83_84_98",TalendDate.formatDate("yyyy-MM-dd'Z'",adresse.DEBUT) );
		if(valueMap.get("loop_83_84_98")!=null) {
			routines.system.NestXMLTool.setText(loop_83_84_98, FormatterUtils.format(TalendDate.formatDate("yyyy-MM-dd'Z'",adresse.DEBUT) ,"dd-MM-yyyy"));
		}
		org.dom4j.Element loop_83_84_99 = null;
				loop_83_84_99 = loop_83_84.addElement("address_types");
		org.dom4j.Element loop_83_84_99_100 = null;
				loop_83_84_99_100 = loop_83_84_99.addElement("address_type");
		valueMap.put("loop_83_84_99_100", adresse.TYPE);
		if(valueMap.get("loop_83_84_99_100")!=null) {
			routines.system.NestXMLTool.setText(loop_83_84_99_100, FormatterUtils.format( adresse.TYPE,null));
		}
				currentValue = null;
    			valueMap.put("loop_83_84_99_100",Character.toUpperCase(adresse.TYPE.charAt(0)) + StringHandling.DOWNCASE( adresse.TYPE.substring(1)) );
    			if(valueMap.get("loop_83_84_99_100")!=null) {
    				currentValue = FormatterUtils.format(Character.toUpperCase(adresse.TYPE.charAt(0)) + StringHandling.DOWNCASE( adresse.TYPE.substring(1)) ,null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_83_84_99_100,  null , "desc", currentValue);
		org.dom4j.Element loop_102 = null;
				loop_102 = loop.addElement("emails");
		org.dom4j.Element loop_102_103 = null;
				loop_102_103 = loop_102.addElement("email");
				currentValue = null;
    			valueMap.put("loop_102_103",(mail.MAIL != null)?((mail.PREF != null)?mail.PREF:"false"):null );
    			if(valueMap.get("loop_102_103")!=null) {
    				currentValue = FormatterUtils.format((mail.MAIL != null)?((mail.PREF != null)?mail.PREF:"false"):null ,null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_102_103,  null , "preferred", currentValue);
				currentValue = null;
    			valueMap.put("loop_102_103",(mail.MAIL != null)?context.sigb_external_desc:null );
    			if(valueMap.get("loop_102_103")!=null) {
    				currentValue = FormatterUtils.format((mail.MAIL != null)?context.sigb_external_desc:null ,null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_102_103,  null , "segment_type", currentValue);
		org.dom4j.Element loop_102_103_106 = null;
				loop_102_103_106 = loop_102_103.addElement("email_address");
		valueMap.put("loop_102_103_106",(mail.MAIL != null)?mail.MAIL:null);
		if(valueMap.get("loop_102_103_106")!=null) {
			routines.system.NestXMLTool.setText(loop_102_103_106, FormatterUtils.format((mail.MAIL != null)?mail.MAIL:null,null));
		}
		org.dom4j.Element loop_102_103_107 = null;
				loop_102_103_107 = loop_102_103.addElement("description");
		org.dom4j.Element loop_102_103_108 = null;
				loop_102_103_108 = loop_102_103.addElement("email_types");
		org.dom4j.Element loop_102_103_108_109 = null;
				loop_102_103_108_109 = loop_102_103_108.addElement("email_type");
		valueMap.put("loop_102_103_108_109",(mail.MAIL != null && !mail.MAIL.trim().isEmpty())?mail.TYPE:null );
		if(valueMap.get("loop_102_103_108_109")!=null) {
			routines.system.NestXMLTool.setText(loop_102_103_108_109, FormatterUtils.format((mail.MAIL != null && !mail.MAIL.trim().isEmpty())?mail.TYPE:null ,null));
		}
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_102_103_108_109,  null , "desc", currentValue);
		org.dom4j.Element loop_111 = null;
				loop_111 = loop.addElement("phones");
		org.dom4j.Element loop_111_112 = null;
				loop_111_112 = loop_111.addElement("phone");
				currentValue = null;
    			valueMap.put("loop_111_112",(telephone.NUMERO != null && !telephone.NUMERO.trim().isEmpty() && telephone.PREF != null)?telephone.PREF:null );
    			if(valueMap.get("loop_111_112")!=null) {
    				currentValue = FormatterUtils.format((telephone.NUMERO != null && !telephone.NUMERO.trim().isEmpty() && telephone.PREF != null)?telephone.PREF:null ,null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_111_112,  null , "preferred", currentValue);
				currentValue = null;
    			valueMap.put("loop_111_112",(telephone.NUMERO != null && !telephone.NUMERO.trim().isEmpty() && telephone.SMS_PREF != null)?telephone.SMS_PREF:null );
    			if(valueMap.get("loop_111_112")!=null) {
    				currentValue = FormatterUtils.format((telephone.NUMERO != null && !telephone.NUMERO.trim().isEmpty() && telephone.SMS_PREF != null)?telephone.SMS_PREF:null ,null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_111_112,  null , "preferred_sms", currentValue);
				currentValue = null;
    			valueMap.put("loop_111_112",(telephone.NUMERO != null && !telephone.NUMERO.trim().isEmpty())?context.sigb_external_desc:null );
    			if(valueMap.get("loop_111_112")!=null) {
    				currentValue = FormatterUtils.format((telephone.NUMERO != null && !telephone.NUMERO.trim().isEmpty())?context.sigb_external_desc:null ,null);
    			}
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_111_112,  null , "segment_type", currentValue);
		org.dom4j.Element loop_111_112_116 = null;
				loop_111_112_116 = loop_111_112.addElement("phone_number");
		valueMap.put("loop_111_112_116",(telephone.NUMERO != null && !telephone.NUMERO.trim().isEmpty())?telephone.NUMERO:null );
		if(valueMap.get("loop_111_112_116")!=null) {
			routines.system.NestXMLTool.setText(loop_111_112_116, FormatterUtils.format((telephone.NUMERO != null && !telephone.NUMERO.trim().isEmpty())?telephone.NUMERO:null ,null));
		}
		org.dom4j.Element loop_111_112_117 = null;
				loop_111_112_117 = loop_111_112.addElement("phone_types");
		org.dom4j.Element loop_111_112_117_118 = null;
				loop_111_112_117_118 = loop_111_112_117.addElement("phone_type");
		valueMap.put("loop_111_112_117_118",(telephone.NUMERO != null && !telephone.NUMERO.trim().isEmpty() && telephone.TYPE != null)?telephone.TYPE:null );
		if(valueMap.get("loop_111_112_117_118")!=null) {
			routines.system.NestXMLTool.setText(loop_111_112_117_118, FormatterUtils.format((telephone.NUMERO != null && !telephone.NUMERO.trim().isEmpty() && telephone.TYPE != null)?telephone.TYPE:null ,null));
		}
				currentValue = null;
    			routines.system.DocumentHelper.applyNamespace2Attribute(loop_111_112_117_118,  null , "desc", currentValue);
		}
    }

	GenerateDocument_xml gen_Doc_xml_tXMLMap_1_TXMLMAP_OUT = new GenerateDocument_xml();
	boolean docAlreadyInstanciate_xml = false;

	            
 



/**
 * [tXMLMap_1_TXMLMAP_OUT begin ] stop
 */



	
	/**
	 * [tOracleInput_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleInput_1", false);
		start_Hash.put("tOracleInput_1", System.currentTimeMillis());
		
	
	currentComponent="tOracleInput_1";

	
		int tos_count_tOracleInput_1 = 0;
		
    	class BytesLimit65535_tOracleInput_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleInput_1().limitLog4jByte();
	


	
		    int nb_line_tOracleInput_1 = 0;
		    java.sql.Connection conn_tOracleInput_1 = null;
		        conn_tOracleInput_1 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
				
				if(((oracle.jdbc.OracleConnection)conn_tOracleInput_1).getSessionTimeZone() == null){
					java.sql.Statement stmtGetTZ_tOracleInput_1 = conn_tOracleInput_1.createStatement();
					java.sql.ResultSet rsGetTZ_tOracleInput_1 = stmtGetTZ_tOracleInput_1.executeQuery("select sessiontimezone from dual");
					String sessionTimezone_tOracleInput_1 = java.util.TimeZone.getDefault().getID();
					while (rsGetTZ_tOracleInput_1.next()) {
						sessionTimezone_tOracleInput_1 = rsGetTZ_tOracleInput_1.getString(1);
					}
					((oracle.jdbc.OracleConnection)conn_tOracleInput_1).setSessionTimeZone(sessionTimezone_tOracleInput_1);
				}
			
		    
			java.sql.Statement stmt_tOracleInput_1 = conn_tOracleInput_1.createStatement();

		    String dbquery_tOracleInput_1 = "SELECT \n  "+context.oracle_schema+".V_SGBMP_INFOGENE.* \nFROM "+context.oracle_schema+".V_SGBMP_INFOGENE "
/*+ " WHERE " + context.oracle_schema+".V_SGBMP_INFOGENE.CODE_BARRE = 'UN17678'"*/;
			

            	globalMap.put("tOracleInput_1_QUERY",dbquery_tOracleInput_1);
		    java.sql.ResultSet rs_tOracleInput_1 = null;

		    try {
		    	rs_tOracleInput_1 = stmt_tOracleInput_1.executeQuery(dbquery_tOracleInput_1);
		    	java.sql.ResultSetMetaData rsmd_tOracleInput_1 = rs_tOracleInput_1.getMetaData();
		    	int colQtyInRs_tOracleInput_1 = rsmd_tOracleInput_1.getColumnCount();

		    String tmpContent_tOracleInput_1 = null;
		    
		    
		    while (rs_tOracleInput_1.next()) {
		        nb_line_tOracleInput_1++;
		        
							if(colQtyInRs_tOracleInput_1 < 1) {
								infogene.CODE_BARRE = null;
							} else {
	                         		
        	infogene.CODE_BARRE = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 1, false);
		                    }
							if(colQtyInRs_tOracleInput_1 < 2) {
								infogene.NOM = null;
							} else {
	                         		
        	infogene.NOM = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 2, false);
		                    }
							if(colQtyInRs_tOracleInput_1 < 3) {
								infogene.PRENOM = null;
							} else {
	                         		
        	infogene.PRENOM = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 3, false);
		                    }
							if(colQtyInRs_tOracleInput_1 < 4) {
								infogene.GROUPE = null;
							} else {
	                         		
        	infogene.GROUPE = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 4, false);
		                    }
							if(colQtyInRs_tOracleInput_1 < 5) {
								infogene.CAMPUS = null;
							} else {
	                         		
        	infogene.CAMPUS = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 5, false);
		                    }
							if(colQtyInRs_tOracleInput_1 < 6) {
								infogene.LANGUE = null;
							} else {
	                         		
        	infogene.LANGUE = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 6, false);
		                    }
							if(colQtyInRs_tOracleInput_1 < 7) {
								infogene.STATUT = null;
							} else {
	                         		
        	infogene.STATUT = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 7, false);
		                    }
							if(colQtyInRs_tOracleInput_1 < 8) {
								infogene.DATE_NAISSANCE = null;
							} else {
										
			infogene.DATE_NAISSANCE = routines.system.JDBCUtil.getDate(rs_tOracleInput_1, 8);
		                    }
							if(colQtyInRs_tOracleInput_1 < 9) {
								infogene.DATE_MODIF = null;
							} else {
										
			infogene.DATE_MODIF = routines.system.JDBCUtil.getDate(rs_tOracleInput_1, 9);
		                    }
							if(colQtyInRs_tOracleInput_1 < 10) {
								infogene.DATE_EXPIRATION = null;
							} else {
										
			infogene.DATE_EXPIRATION = routines.system.JDBCUtil.getDate(rs_tOracleInput_1, 10);
		                    }
							if(colQtyInRs_tOracleInput_1 < 11) {
								infogene.DATE_ELIMINATION = null;
							} else {
										
			infogene.DATE_ELIMINATION = routines.system.JDBCUtil.getDate(rs_tOracleInput_1, 11);
		                    }
							if(colQtyInRs_tOracleInput_1 < 12) {
								infogene.EPPN = null;
							} else {
	                         		
        	infogene.EPPN = routines.system.JDBCUtil.getString(rs_tOracleInput_1, 12, false);
		                    }
					




 



/**
 * [tOracleInput_1 begin ] stop
 */
	
	/**
	 * [tOracleInput_1 main ] start
	 */

	

	
	
	currentComponent="tOracleInput_1";

	

 


	tos_count_tOracleInput_1++;

/**
 * [tOracleInput_1 main ] stop
 */

	
	/**
	 * [tXMLMap_1_TXMLMAP_OUT main ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_1";
	
	currentComponent="tXMLMap_1_TXMLMAP_OUT";

	

			//infogene
			//infogene


			
				if(execStat){
					runStat.updateStatOnConnection("infogene"+iterateId,1, 1);
				} 
			

		

	boolean rejectedInnerJoin_tXMLMap_1_TXMLMAP_OUT = false;
	boolean rejectedDocInnerJoin_tXMLMap_1_TXMLMAP_OUT = false;
	boolean mainRowRejected_tXMLMap_1_TXMLMAP_OUT = false;
	boolean isMatchDocRowtXMLMap_1_TXMLMAP_OUT = false;
	  
	
			
   
					xml_tmp.doc = null;
					
		
		


			

			
				///////////////////////////////////////////////
				//Starting Lookup Table "org.talend.designer.xmlmap.model.emf.xmlmap.impl.InputXmlTreeImpl@7b0c83c4 (expressionFilter: null, activateExpressionFilter: false, activateCondensedTool: true, minimized: false, name: mail, multiLoops: false) (lookup: true, matchingMode: ALL_MATCHES, lookupMode: LOAD_ONCE, innerJoin: false, persistent: false, activateGlobalMap: false)" 
				///////////////////////////////////////////////
				//tHash_Lookup_mail.initGet();
				
				
				
					boolean forceLoopmail = false;
					mailStruct mailObjectFromLookup = null;
					boolean hasResultFromLookupCachemail = false;
					java.util.Map<String,Object> cacheResultmail = new java.util.HashMap<String,Object>();
				
				
				
					   	mailHashKey.CODE_BARRE = infogene.CODE_BARRE;
						mailHashKey.hashCodeDirty = true;
						
					
					
						if(!rejectedInnerJoin_tXMLMap_1_TXMLMAP_OUT){//TD120
							
					
							
								
									tHash_Lookup_mail.lookup( mailHashKey );
								
							
							if(hasResultFromLookupCachemail  || tHash_Lookup_mail.hasNext()){
							
							} else {
								
									mail = mailDefault;
								
								
								
								forceLoopmail = true;
								
							}
						}//TD120
				   
				   		
				   			if(rejectedInnerJoin_tXMLMap_1_TXMLMAP_OUT) {
				   				forceLoopmail = true;
				   			}
				   		
				   
				   		mailStruct fromLookup_mail = null;
						mail = mailDefault;
				   
				   		
				  		
				  		//////////////////////////////////////////////////////////////////////////////////////////////
				  		
				  		boolean fromCachemail = hasResultFromLookupCachemail;
				  		List<java.util.Map<String,Object>> multipleResultSetmail = new java.util.ArrayList<java.util.Map<String,Object>>();
				  		//the var for cache the mailStruct
				  		java.util.Map<String,Object> oneRow_mail = null;
						if(hasResultFromLookupCachemail) {
					    	
					    } else if(!rejectedInnerJoin_tXMLMap_1_TXMLMAP_OUT) {
					    	
					    	while (tHash_Lookup_mail.hasNext()) {
					    		fromLookup_mail = null;
								mail = mailDefault;
								fromLookup_mail = tHash_Lookup_mail.next();
								if(fromLookup_mail != null) {
								
										
									mail = fromLookup_mail;
									//construct the resultset for mutiple lookup when no document lookup.
									oneRow_mail = new java.util.HashMap<String, Object>();
									oneRow_mail.put("mail",mail);
									multipleResultSetmail.add(oneRow_mail);
									
								}
					    	}//end while
					    	
					    }//end else if
					    //now not support cache all_matches lookup
					    
					    
					    
					    
					    java.util.Iterator<java.util.Map<String,Object>> itermail = multipleResultSetmail.iterator();
					    while(itermail.hasNext() || forceLoopmail) { // G_TM_M_002
					    	mail = mailDefault;
					    	mailStruct tempLookupmail = null; 
					    	if(!forceLoopmail) {
						    	java.util.Map<String,Object> oneRowmail = itermail.next();
						   		
					    		tempLookupmail = (mailStruct)oneRowmail.get("mail");
					    		if(tempLookupmail!=null) {
					    			mail = tempLookupmail;
					    		}
					    		
					    		
				    		}
				    		forceLoopmail = false;
				  		
				  		/////////////////////////////////////////////////////////////////////////////////////////////////
				  		
					
				

			
				///////////////////////////////////////////////
				//Starting Lookup Table "org.talend.designer.xmlmap.model.emf.xmlmap.impl.InputXmlTreeImpl@5895d565 (expressionFilter: null, activateExpressionFilter: false, activateCondensedTool: false, minimized: false, name: adresse, multiLoops: false) (lookup: true, matchingMode: UNIQUE_MATCH, lookupMode: LOAD_ONCE, innerJoin: false, persistent: false, activateGlobalMap: false)" 
				///////////////////////////////////////////////
				//tHash_Lookup_adresse.initGet();
				
				
				
					boolean forceLoopadresse = false;
					adresseStruct adresseObjectFromLookup = null;
					boolean hasResultFromLookupCacheadresse = false;
					java.util.Map<String,Object> cacheResultadresse = new java.util.HashMap<String,Object>();
				
				
				
					   	adresseHashKey.CODE_BARRE = infogene.CODE_BARRE;
						adresseHashKey.hashCodeDirty = true;
						
					
					
						if(!rejectedInnerJoin_tXMLMap_1_TXMLMAP_OUT){//TD120
							
					
							
								
									tHash_Lookup_adresse.lookup( adresseHashKey );
								
							
							if(hasResultFromLookupCacheadresse  || tHash_Lookup_adresse.hasNext()){
							
							} else {
								
									adresse = adresseDefault;
								
								
								
							}
						}//TD120
				   
				   		
				   
				   		adresseStruct fromLookup_adresse = null;
						adresse = adresseDefault;
				   
				   		
					    if(hasResultFromLookupCacheadresse) {//TD10086
					    	
					    } else if(!rejectedInnerJoin_tXMLMap_1_TXMLMAP_OUT) {
						  	
							while (tHash_Lookup_adresse.hasNext()) {//TD119
								fromLookup_adresse = null;
								adresse = adresseDefault;
								fromLookup_adresse = tHash_Lookup_adresse.next();
								if (fromLookup_adresse != null) {
								
									adresse = fromLookup_adresse;
									
									
									
									
								}
							}//TD119
							
						  	
						  	
				  		}//TD10086
				  		
				  		
				  		
				  		//////////////////////////////////////////////////////////////////////////////////////////////
				  		
				  		/////////////////////////////////////////////////////////////////////////////////////////////////
				  		
					
				

			
				///////////////////////////////////////////////
				//Starting Lookup Table "org.talend.designer.xmlmap.model.emf.xmlmap.impl.InputXmlTreeImpl@7fe88844 (expressionFilter: null, activateExpressionFilter: false, activateCondensedTool: false, minimized: false, name: telephone, multiLoops: false) (lookup: true, matchingMode: UNIQUE_MATCH, lookupMode: LOAD_ONCE, innerJoin: false, persistent: false, activateGlobalMap: false)" 
				///////////////////////////////////////////////
				//tHash_Lookup_telephone.initGet();
				
				
				
					boolean forceLooptelephone = false;
					telephoneStruct telephoneObjectFromLookup = null;
					boolean hasResultFromLookupCachetelephone = false;
					java.util.Map<String,Object> cacheResulttelephone = new java.util.HashMap<String,Object>();
				
				
				
					   	telephoneHashKey.CODE_BARRE = infogene.CODE_BARRE;
						telephoneHashKey.hashCodeDirty = true;
						
					
					
						if(!rejectedInnerJoin_tXMLMap_1_TXMLMAP_OUT){//TD120
							
					
							
								
									tHash_Lookup_telephone.lookup( telephoneHashKey );
								
							
							if(hasResultFromLookupCachetelephone  || tHash_Lookup_telephone.hasNext()){
							
							} else {
								
									telephone = telephoneDefault;
								
								
								
							}
						}//TD120
				   
				   		
				   
				   		telephoneStruct fromLookup_telephone = null;
						telephone = telephoneDefault;
				   
				   		
					    if(hasResultFromLookupCachetelephone) {//TD10086
					    	
					    } else if(!rejectedInnerJoin_tXMLMap_1_TXMLMAP_OUT) {
						  	
							while (tHash_Lookup_telephone.hasNext()) {//TD119
								fromLookup_telephone = null;
								telephone = telephoneDefault;
								fromLookup_telephone = tHash_Lookup_telephone.next();
								if (fromLookup_telephone != null) {
								
									telephone = fromLookup_telephone;
									
									
									
									
								}
							}//TD119
							
						  	
						  	
				  		}//TD10086
				  		
				  		
				  		
				  		//////////////////////////////////////////////////////////////////////////////////////////////
				  		
				  		/////////////////////////////////////////////////////////////////////////////////////////////////
				  		
					
				

			
				///////////////////////////////////////////////
				//Starting Lookup Table "org.talend.designer.xmlmap.model.emf.xmlmap.impl.InputXmlTreeImpl@35b32aff (expressionFilter: null, activateExpressionFilter: false, activateCondensedTool: false, minimized: false, name: statistiques, multiLoops: false) (lookup: true, matchingMode: UNIQUE_MATCH, lookupMode: LOAD_ONCE, innerJoin: false, persistent: false, activateGlobalMap: false)" 
				///////////////////////////////////////////////
				//tHash_Lookup_statistiques.initGet();
				
				
				
					boolean forceLoopstatistiques = false;
					statistiquesStruct statistiquesObjectFromLookup = null;
					boolean hasResultFromLookupCachestatistiques = false;
					java.util.Map<String,Object> cacheResultstatistiques = new java.util.HashMap<String,Object>();
				
				
				
					   	statistiquesHashKey.CODE_BARRE = infogene.CODE_BARRE;
						statistiquesHashKey.hashCodeDirty = true;
						
					
					
						if(!rejectedInnerJoin_tXMLMap_1_TXMLMAP_OUT){//TD120
							
					
							
								
									tHash_Lookup_statistiques.lookup( statistiquesHashKey );
								
							
							if(hasResultFromLookupCachestatistiques  || tHash_Lookup_statistiques.hasNext()){
							
							} else {
								
									statistiques = statistiquesDefault;
								
								
								
							}
						}//TD120
				   
				   		
				   
				   		statistiquesStruct fromLookup_statistiques = null;
						statistiques = statistiquesDefault;
				   
				   		
					    if(hasResultFromLookupCachestatistiques) {//TD10086
					    	
					    } else if(!rejectedInnerJoin_tXMLMap_1_TXMLMAP_OUT) {
						  	
							while (tHash_Lookup_statistiques.hasNext()) {//TD119
								fromLookup_statistiques = null;
								statistiques = statistiquesDefault;
								fromLookup_statistiques = tHash_Lookup_statistiques.next();
								if (fromLookup_statistiques != null) {
								
									statistiques = fromLookup_statistiques;
									
									
									
									
								}
							}//TD119
							
						  	
						  	
				  		}//TD10086
				  		
				  		
				  		
				  		//////////////////////////////////////////////////////////////////////////////////////////////
				  		
				  		/////////////////////////////////////////////////////////////////////////////////////////////////
				  		
					
				
{ // start of Var scope

	// ###############################
	// # Vars tables

Var__tXMLMap_1_TXMLMAP_OUT__Struct Var = Var__tXMLMap_1_TXMLMAP_OUT;

			
Var.fullname = infogene.PRENOM + " " + infogene.NOM ;
		// ###############################
		// # Output tables

xml = null;


// # Output table : 'xml'

if(!docAlreadyInstanciate_xml) {
docAlreadyInstanciate_xml = true;gen_Doc_xml_tXMLMap_1_TXMLMAP_OUT = new GenerateDocument_xml();
//init one new out struct for cache the result.
xml_aggregate = new xmlStruct();
xml_aggregate.doc = new routines.system.Document();
xml_aggregate.doc.setDocument(gen_Doc_xml_tXMLMap_1_TXMLMAP_OUT.getDocument());

//construct the resultset
allOutsForAggregate_tXMLMap_1.add(xml_aggregate);
}


gen_Doc_xml_tXMLMap_1_TXMLMAP_OUT.generateElements(rejectedDocInnerJoin_tXMLMap_1_TXMLMAP_OUT,infogene,mail,adresse,telephone,statistiques,Var);


// ###############################

} // end of Var scope

rejectedInnerJoin_tXMLMap_1_TXMLMAP_OUT = false;


		}// G_TM_M_002

 


	tos_count_tXMLMap_1_TXMLMAP_OUT++;

/**
 * [tXMLMap_1_TXMLMAP_OUT main ] stop
 */



	
	/**
	 * [tOracleInput_1 end ] start
	 */

	

	
	
	currentComponent="tOracleInput_1";

	

}
}finally{
stmt_tOracleInput_1.close();

}

globalMap.put("tOracleInput_1_NB_LINE",nb_line_tOracleInput_1);
 

ok_Hash.put("tOracleInput_1", true);
end_Hash.put("tOracleInput_1", System.currentTimeMillis());




/**
 * [tOracleInput_1 end ] stop
 */

	
	/**
	 * [tXMLMap_1_TXMLMAP_OUT end ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_1";
	
	currentComponent="tXMLMap_1_TXMLMAP_OUT";

	




			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("infogene"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tXMLMap_1_TXMLMAP_OUT", true);
end_Hash.put("tXMLMap_1_TXMLMAP_OUT", System.currentTimeMillis());




/**
 * [tXMLMap_1_TXMLMAP_OUT end ] stop
 */


	
	/**
	 * [tFileOutputXML_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tFileOutputXML_1", false);
		start_Hash.put("tFileOutputXML_1", System.currentTimeMillis());
		
	
	currentComponent="tFileOutputXML_1";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("xml" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tFileOutputXML_1 = 0;
		
    	class BytesLimit65535_tFileOutputXML_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tFileOutputXML_1().limitLog4jByte();


	String originalFileName_tFileOutputXML_1 = context.sigb_files_dir+context.sigb_file_name+".xml";
	java.io.File originalFile_tFileOutputXML_1 = new java.io.File(originalFileName_tFileOutputXML_1); 

	String fileName_tFileOutputXML_1 = originalFileName_tFileOutputXML_1;
	java.io.File file_tFileOutputXML_1 = new java.io.File(fileName_tFileOutputXML_1); 
	if(!file_tFileOutputXML_1.isAbsolute()) {
		file_tFileOutputXML_1 = file_tFileOutputXML_1.getCanonicalFile();
	}

	//create directory only if not exists
	
	file_tFileOutputXML_1.getParentFile().mkdirs();
	
	int nb_line_tFileOutputXML_1 = 0;
	org.dom4j.io.OutputFormat format_tFileOutputXML_1 = org.dom4j.io.OutputFormat.createPrettyPrint();
	format_tFileOutputXML_1.setEncoding("UTF-8");
	format_tFileOutputXML_1.setNewLineAfterDeclaration(false);
	format_tFileOutputXML_1.setTrimText(true);
	org.dom4j.io.XMLWriter writer_tFileOutputXML_1 = new org.dom4j.io.XMLWriter(new java.io.OutputStreamWriter(new java.io.FileOutputStream(file_tFileOutputXML_1), "UTF-8"), format_tFileOutputXML_1);

 



/**
 * [tFileOutputXML_1 begin ] stop
 */



	
	/**
	 * [tXMLMap_1_TXMLMAP_IN begin ] start
	 */

	

	
		
		ok_Hash.put("tXMLMap_1_TXMLMAP_IN", false);
		start_Hash.put("tXMLMap_1_TXMLMAP_IN", System.currentTimeMillis());
		
	
		currentVirtualComponent = "tXMLMap_1";
	
	currentComponent="tXMLMap_1_TXMLMAP_IN";

	
		int tos_count_tXMLMap_1_TXMLMAP_IN = 0;
		
    	class BytesLimit65535_tXMLMap_1_TXMLMAP_IN{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tXMLMap_1_TXMLMAP_IN().limitLog4jByte();
java.util.List<Object> outs_tXMLMap_1 = (java.util.List<Object>)globalMap.get("allOutsForAggregate_tXMLMap_1");
for(Object  row_out_tXMLMap_1_TXMLMAP_IN : outs_tXMLMap_1) {//TD512
 



/**
 * [tXMLMap_1_TXMLMAP_IN begin ] stop
 */
	
	/**
	 * [tXMLMap_1_TXMLMAP_IN main ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_1";
	
	currentComponent="tXMLMap_1_TXMLMAP_IN";

	

	xml = null;
	if(row_out_tXMLMap_1_TXMLMAP_IN!=null && row_out_tXMLMap_1_TXMLMAP_IN instanceof xmlStruct) {
		xml = (xmlStruct)row_out_tXMLMap_1_TXMLMAP_IN;
			routines.system.NestXMLTool.generateOk(xml.doc, true);		
	}
 


	tos_count_tXMLMap_1_TXMLMAP_IN++;

/**
 * [tXMLMap_1_TXMLMAP_IN main ] stop
 */
// Start of branch "xml"
if(xml != null) { 



	
	/**
	 * [tFileOutputXML_1 main ] start
	 */

	

	
	
	currentComponent="tFileOutputXML_1";

	

			//xml
			//xml


			
				if(execStat){
					runStat.updateStatOnConnection("xml"+iterateId,1, 1);
				} 
			

		


					nb_line_tFileOutputXML_1++;
					writer_tFileOutputXML_1.write(xml.doc.getDocument());
					

 


	tos_count_tFileOutputXML_1++;

/**
 * [tFileOutputXML_1 main ] stop
 */

} // End of branch "xml"




	
	/**
	 * [tXMLMap_1_TXMLMAP_IN end ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_1";
	
	currentComponent="tXMLMap_1_TXMLMAP_IN";

	

}//TD512
 

ok_Hash.put("tXMLMap_1_TXMLMAP_IN", true);
end_Hash.put("tXMLMap_1_TXMLMAP_IN", System.currentTimeMillis());




/**
 * [tXMLMap_1_TXMLMAP_IN end ] stop
 */

	
	/**
	 * [tFileOutputXML_1 end ] start
	 */

	

	
	
	currentComponent="tFileOutputXML_1";

	


	writer_tFileOutputXML_1.close();
	
	if(nb_line_tFileOutputXML_1 == 0){
		file_tFileOutputXML_1.delete();
	}			

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("xml"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tFileOutputXML_1", true);
end_Hash.put("tFileOutputXML_1", System.currentTimeMillis());

				if(execStat){   
   	 				runStat.updateStatOnConnection("OnComponentOk6", 0, "ok");
				}
				tFileArchive_1Process(globalMap);



/**
 * [tFileOutputXML_1 end ] stop
 */









				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
					te.setVirtualComponentName(currentVirtualComponent);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleInput_1 finally ] start
	 */

	

	
	
	currentComponent="tOracleInput_1";

	

 



/**
 * [tOracleInput_1 finally ] stop
 */

	
	/**
	 * [tXMLMap_1_TXMLMAP_OUT finally ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_1";
	
	currentComponent="tXMLMap_1_TXMLMAP_OUT";

	

 



/**
 * [tXMLMap_1_TXMLMAP_OUT finally ] stop
 */

	
	/**
	 * [tXMLMap_1_TXMLMAP_IN finally ] start
	 */

	

	
	
		currentVirtualComponent = "tXMLMap_1";
	
	currentComponent="tXMLMap_1_TXMLMAP_IN";

	

 



/**
 * [tXMLMap_1_TXMLMAP_IN finally ] stop
 */

	
	/**
	 * [tFileOutputXML_1 finally ] start
	 */

	

	
	
	currentComponent="tFileOutputXML_1";

	

 



/**
 * [tFileOutputXML_1 finally ] stop
 */









				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleInput_1_SUBPROCESS_STATE", 1);
	}
	


public static class row2Struct implements routines.system.IPersistableRow<row2Struct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];

	
			    public routines.system.Document doc;

				public routines.system.Document getDoc () {
					return this.doc;
				}
				



    public void readData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
						this.doc = (routines.system.Document) dis.readObject();
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		
			} catch(ClassNotFoundException eCNFE) {
				 throw new RuntimeException(eCNFE);
		

        }

		

      }


    }

    public void writeData(ObjectOutputStream dos) {
        try {

		
					// Document
				
       			    	dos.writeObject(this.doc);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("doc="+String.valueOf(doc));
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(row2Struct other) {

		int returnValue = -1;
		
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tFileArchive_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tFileArchive_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		row2Struct row2 = new row2Struct();




	
	/**
	 * [tSCPPut_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tSCPPut_1", false);
		start_Hash.put("tSCPPut_1", System.currentTimeMillis());
		
	
	currentComponent="tSCPPut_1";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("row2" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tSCPPut_1 = 0;
		
    	class BytesLimit65535_tSCPPut_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tSCPPut_1().limitLog4jByte();

 
	int nb_file_tSCPPut_1 = 0;
	globalMap.put("tSCPPut_1_STATUS", "");
    /* Create a connection instance */
	
		ch.ethz.ssh2.Connection conn_tSCPPut_1 = (ch.ethz.ssh2.Connection)globalMap.get("conn_tSCPConnection_1");
		
	
	
        ch.ethz.ssh2.SCPClient scp_tSCPPut_1 = new  ch.ethz.ssh2.SCPClient(conn_tSCPPut_1);
		
        java.util.List<String> sourceList_tSCPPut_1 = new java.util.ArrayList<String>();
			if((new java.io.File(context.sigb_files_dir+context.sigb_file_name + ".zip").exists()) 
			&& (new java.io.File(context.sigb_files_dir+context.sigb_file_name + ".zip").isFile())){
				sourceList_tSCPPut_1.add(context.sigb_files_dir+context.sigb_file_name + ".zip");
			}else{
        }   
		String[] sourceFileNames_tSCPPut_1 = new String[sourceList_tSCPPut_1.size()];
        for(int i_tSCPPut_1 = 0;i_tSCPPut_1 < sourceList_tSCPPut_1.size(); i_tSCPPut_1++){
        	sourceFileNames_tSCPPut_1[i_tSCPPut_1] = sourceList_tSCPPut_1.get(i_tSCPPut_1);
        }

 



/**
 * [tSCPPut_1 begin ] stop
 */



	
	/**
	 * [tFileArchive_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tFileArchive_1", false);
		start_Hash.put("tFileArchive_1", System.currentTimeMillis());
		
	
	currentComponent="tFileArchive_1";

	
		int tos_count_tFileArchive_1 = 0;
		
    	class BytesLimit65535_tFileArchive_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tFileArchive_1().limitLog4jByte();

 



/**
 * [tFileArchive_1 begin ] stop
 */
	
	/**
	 * [tFileArchive_1 main ] start
	 */

	

	
	
	currentComponent="tFileArchive_1";

	

	
	
		String sourceFile_tFileArchive_1 = context.sigb_files_dir;
	
    String zipFile_tFileArchive_1 = context.sigb_files_dir + context.sigb_file_name + ".zip";
    
    com.talend.compress.zip.Zip zip_tFileArchive_1 = new com.talend.compress.zip.Zip(sourceFile_tFileArchive_1, zipFile_tFileArchive_1);
    zip_tFileArchive_1.setOverwriteExistTargetZip(true);
	zip_tFileArchive_1.setMakeTargetDir(false);
	zip_tFileArchive_1.setCompressLevel(9);
	zip_tFileArchive_1.setArchiveFormat("zip");
	zip_tFileArchive_1.setAllFiles(false);
	
	  
    	//build filename pattern filter
	    String[] patterns_tFileArchive_1 = new String[1];
    	
	        patterns_tFileArchive_1[0] = context.sigb_file_name + ".xml";
  		StringBuilder sbf_tFileArchive_1 = new StringBuilder(); 
        sbf_tFileArchive_1.append("(");
        for (int i_tFileArchive_1 = 0 ; i_tFileArchive_1 < patterns_tFileArchive_1.length ; i_tFileArchive_1++) {
            sbf_tFileArchive_1.append(patterns_tFileArchive_1[i_tFileArchive_1].replaceAll("\\.", "\\\\.").replaceAll("\\*", ".*"));
            if(i_tFileArchive_1 != patterns_tFileArchive_1.length-1) sbf_tFileArchive_1.append("|");
        }        
        sbf_tFileArchive_1.append(")");
        final String maskStr_tFileArchive_1 = new String(sbf_tFileArchive_1.toString());
        
        //apply the filter
       	zip_tFileArchive_1.setNamePatternFilter(maskStr_tFileArchive_1);
	
	   zip_tFileArchive_1.setContainSubDir(true);
	   zip_tFileArchive_1.setEncoding("UTF-8");
	   zip_tFileArchive_1.setZip64Mode("ASNEEDED");
	   zip_tFileArchive_1.setEncrypted(false);
		        
	   
	    
	    
	final String decryptedPassword_tFileArchive_1 = routines.system.PasswordEncryptUtil.decryptPassword("f4f7aba1746784ea");
	    
	   zip_tFileArchive_1.setPassword(decryptedPassword_tFileArchive_1);
	   
	      zip_tFileArchive_1.setUseZip4jEncryption(true);
	      zip_tFileArchive_1.setEncryptionMethod(net.lingala.zip4j.util.Zip4jConstants.ENC_METHOD_STANDARD);
	      
  
  
   globalMap.put("tFileArchive_1_ARCHIVE_FILEPATH",zipFile_tFileArchive_1);
   
   globalMap.put("tFileArchive_1_ARCHIVE_FILENAME", new java.io.File(zipFile_tFileArchive_1).getName());

   zip_tFileArchive_1.doZip();


 


	tos_count_tFileArchive_1++;

/**
 * [tFileArchive_1 main ] stop
 */

	
	/**
	 * [tSCPPut_1 main ] start
	 */

	

	
	
	currentComponent="tSCPPut_1";

	

			//row2
			//row2


			
				if(execStat){
					runStat.updateStatOnConnection("row2"+iterateId,1, 1);
				} 
			

		

	try{
        if(sourceFileNames_tSCPPut_1!=null && sourceFileNames_tSCPPut_1.length!=0){
           	for (int i_tSCPPut_1 = 0; i_tSCPPut_1 < sourceFileNames_tSCPPut_1.length; i_tSCPPut_1++) {
       			java.io.File file_tSCPPut_1 = new java.io.File(sourceFileNames_tSCPPut_1[i_tSCPPut_1]);
       			long sendSize_tSCPPut_1 = file_tSCPPut_1.length();
       			String remoteName_tSCPPut_1 = file_tSCPPut_1.getName();
       			java.io.OutputStream out_tSCPPut_1 = null;
       			java.io.InputStream is_tSCPPut_1 = null;
				byte[] buffer_tSCPPut_1 = new byte[8192];
				int receive_tSCPPut_1 = -1;
				try {
					out_tSCPPut_1 = scp_tSCPPut_1.put(remoteName_tSCPPut_1, sendSize_tSCPPut_1, context.sigb_biu_dir, "0644");
					is_tSCPPut_1 = new java.io.FileInputStream(file_tSCPPut_1);
					
    				while((receive_tSCPPut_1 = is_tSCPPut_1.read(buffer_tSCPPut_1))!=-1) {
						out_tSCPPut_1.write(buffer_tSCPPut_1, 0, receive_tSCPPut_1);
    				}
				} finally {
                	if(out_tSCPPut_1 != null){
            			out_tSCPPut_1.close();
                	}
                	
                	if(is_tSCPPut_1 != null) {
            			is_tSCPPut_1.close();
                	}
				}
           	}
			
            nb_file_tSCPPut_1 = sourceFileNames_tSCPPut_1.length;
            globalMap.put("tSCPPut_1_STATUS", "File put OK.");
        }else{
        	globalMap.put("tSCPPut_1_STATUS", "No file transfered.");
        }
    }catch(java.lang.Exception e){
    		e.printStackTrace();
    		
    		globalMap.put("tSCPPut_1_STATUS", "File put fail.");
    }

 


	tos_count_tSCPPut_1++;

/**
 * [tSCPPut_1 main ] stop
 */



	
	/**
	 * [tFileArchive_1 end ] start
	 */

	

	
	
	currentComponent="tFileArchive_1";

	

 

ok_Hash.put("tFileArchive_1", true);
end_Hash.put("tFileArchive_1", System.currentTimeMillis());




/**
 * [tFileArchive_1 end ] stop
 */

	
	/**
	 * [tSCPPut_1 end ] start
	 */

	

	
	
	currentComponent="tSCPPut_1";

	

		globalMap.put("tSCPPut_1_NB_FILE",nb_file_tSCPPut_1);
			
		

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("row2"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tSCPPut_1", true);
end_Hash.put("tSCPPut_1", System.currentTimeMillis());




/**
 * [tSCPPut_1 end ] stop
 */



				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tFileArchive_1 finally ] start
	 */

	

	
	
	currentComponent="tFileArchive_1";

	

 



/**
 * [tFileArchive_1 finally ] stop
 */

	
	/**
	 * [tSCPPut_1 finally ] start
	 */

	

	
	
	currentComponent="tSCPPut_1";

	

 



/**
 * [tSCPPut_1 finally ] stop
 */



				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tFileArchive_1_SUBPROCESS_STATE", 1);
	}
	


public static class mailStruct implements routines.system.IPersistableComparableLookupRow<mailStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];
	protected static final int DEFAULT_HASHCODE = 1;
    protected static final int PRIME = 31;
    protected int hashCode = DEFAULT_HASHCODE;
    public boolean hashCodeDirty = true;

    public String loopKey;



	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String TYPE;

				public String getTYPE () {
					return this.TYPE;
				}
				
			    public String MAIL;

				public String getMAIL () {
					return this.MAIL;
				}
				
			    public String PREF;

				public String getPREF () {
					return this.PREF;
				}
				


	@Override
	public int hashCode() {
		if (this.hashCodeDirty) {
			final int prime = PRIME;
			int result = DEFAULT_HASHCODE;
	
						result = prime * result + ((this.CODE_BARRE == null) ? 0 : this.CODE_BARRE.hashCode());
					
    		this.hashCode = result;
    		this.hashCodeDirty = false;
		}
		return this.hashCode;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
		if (obj == null) return false;
		if (getClass() != obj.getClass()) return false;
		final mailStruct other = (mailStruct) obj;
		
						if (this.CODE_BARRE == null) {
							if (other.CODE_BARRE != null)
								return false;
						
						} else if (!this.CODE_BARRE.equals(other.CODE_BARRE))
						
							return false;
					

		return true;
    }

	public void copyDataTo(mailStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            other.TYPE = this.TYPE;
	            other.MAIL = this.MAIL;
	            other.PREF = this.PREF;
	            
	}

	public void copyKeysDataTo(mailStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            	
	}




	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private String readString(DataInputStream dis, ObjectInputStream ois) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			byte[] byteArray = new byte[length];
			dis.read(byteArray);
			strReturn = new String(byteArray, utf8Charset);
		}
		return strReturn;
	}

	private void writeString(String str, DataOutputStream dos, ObjectOutputStream oos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
	}

    public void readKeysData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeKeysData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }



    /**
     * Fill Values data by reading ObjectInputStream.
     */
    public void readValuesData(DataInputStream dis, ObjectInputStream ois) {
        try {

			int length = 0;
		
						this.TYPE = readString(dis,ois);
					
						this.MAIL = readString(dis,ois);
					
						this.PREF = readString(dis,ois);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

    }

    /**
     * Return a byte array which represents Values data.
     */
    public void writeValuesData(DataOutputStream dos, ObjectOutputStream oos) {
        try {

		
						writeString(this.TYPE, dos, oos);
					
						writeString(this.MAIL, dos, oos);
					
						writeString(this.PREF, dos, oos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        	}

    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",TYPE="+TYPE);
		sb.append(",MAIL="+MAIL);
		sb.append(",PREF="+PREF);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(mailStruct other) {

		int returnValue = -1;
		
						returnValue = checkNullsAndCompare(this.CODE_BARRE, other.CODE_BARRE);
						if(returnValue != 0) {
							return returnValue;
						}

					
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tOracleInput_2Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleInput_2_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		mailStruct mail = new mailStruct();




	
	/**
	 * [tAdvancedXMLMapHash_mail begin ] start
	 */

	

	
		
		ok_Hash.put("tAdvancedXMLMapHash_mail", false);
		start_Hash.put("tAdvancedXMLMapHash_mail", System.currentTimeMillis());
		
	
	currentComponent="tAdvancedXMLMapHash_mail";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("mail" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tAdvancedXMLMapHash_mail = 0;
		
    	class BytesLimit65535_tAdvancedXMLMapHash_mail{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tAdvancedXMLMapHash_mail().limitLog4jByte();

			   		// connection name:mail
			   		// source node:tOracleInput_2 - inputs:(after_tOracleInput_1) outputs:(mail,mail) | target node:tAdvancedXMLMapHash_mail - inputs:(mail) outputs:()
			   		// linked node: tXMLMap_1 - inputs:(infogene,mail,adresse,telephone,statistiques) outputs:(xml)
			   
			   		org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE matchingModeEnum_mail = 
			   			org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE.ALL_MATCHES;
			   
			   
	   				org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<mailStruct> tHash_Lookup_mail = 
	   					org.talend.designer.components.lookup.memory.AdvancedMemoryLookup.
	   						<mailStruct>getLookup(matchingModeEnum_mail);

		   	   	   globalMap.put("tHash_Lookup_mail", tHash_Lookup_mail);
		   	   	   
				
            

 



/**
 * [tAdvancedXMLMapHash_mail begin ] stop
 */



	
	/**
	 * [tOracleInput_2 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleInput_2", false);
		start_Hash.put("tOracleInput_2", System.currentTimeMillis());
		
	
	currentComponent="tOracleInput_2";

	
		int tos_count_tOracleInput_2 = 0;
		
    	class BytesLimit65535_tOracleInput_2{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleInput_2().limitLog4jByte();
	


	
		    int nb_line_tOracleInput_2 = 0;
		    java.sql.Connection conn_tOracleInput_2 = null;
		        conn_tOracleInput_2 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
				
				if(((oracle.jdbc.OracleConnection)conn_tOracleInput_2).getSessionTimeZone() == null){
					java.sql.Statement stmtGetTZ_tOracleInput_2 = conn_tOracleInput_2.createStatement();
					java.sql.ResultSet rsGetTZ_tOracleInput_2 = stmtGetTZ_tOracleInput_2.executeQuery("select sessiontimezone from dual");
					String sessionTimezone_tOracleInput_2 = java.util.TimeZone.getDefault().getID();
					while (rsGetTZ_tOracleInput_2.next()) {
						sessionTimezone_tOracleInput_2 = rsGetTZ_tOracleInput_2.getString(1);
					}
					((oracle.jdbc.OracleConnection)conn_tOracleInput_2).setSessionTimeZone(sessionTimezone_tOracleInput_2);
				}
			
		    
			java.sql.Statement stmt_tOracleInput_2 = conn_tOracleInput_2.createStatement();

		    String dbquery_tOracleInput_2 = "SELECT \n  "+context.oracle_schema+".V_SGBMP_MAIL.*\nFROM "+context.oracle_schema+".V_SGBMP_MAIL";
			

            	globalMap.put("tOracleInput_2_QUERY",dbquery_tOracleInput_2);
		    java.sql.ResultSet rs_tOracleInput_2 = null;

		    try {
		    	rs_tOracleInput_2 = stmt_tOracleInput_2.executeQuery(dbquery_tOracleInput_2);
		    	java.sql.ResultSetMetaData rsmd_tOracleInput_2 = rs_tOracleInput_2.getMetaData();
		    	int colQtyInRs_tOracleInput_2 = rsmd_tOracleInput_2.getColumnCount();

		    String tmpContent_tOracleInput_2 = null;
		    
		    
		    while (rs_tOracleInput_2.next()) {
		        nb_line_tOracleInput_2++;
		        
							if(colQtyInRs_tOracleInput_2 < 1) {
								mail.CODE_BARRE = null;
							} else {
	                         		
        	mail.CODE_BARRE = routines.system.JDBCUtil.getString(rs_tOracleInput_2, 1, false);
		                    }
							if(colQtyInRs_tOracleInput_2 < 2) {
								mail.TYPE = null;
							} else {
	                         		
        	mail.TYPE = routines.system.JDBCUtil.getString(rs_tOracleInput_2, 2, false);
		                    }
							if(colQtyInRs_tOracleInput_2 < 3) {
								mail.MAIL = null;
							} else {
	                         		
        	mail.MAIL = routines.system.JDBCUtil.getString(rs_tOracleInput_2, 3, false);
		                    }
							if(colQtyInRs_tOracleInput_2 < 4) {
								mail.PREF = null;
							} else {
	                         		
        	mail.PREF = routines.system.JDBCUtil.getString(rs_tOracleInput_2, 4, false);
		                    }
					




 



/**
 * [tOracleInput_2 begin ] stop
 */
	
	/**
	 * [tOracleInput_2 main ] start
	 */

	

	
	
	currentComponent="tOracleInput_2";

	

 


	tos_count_tOracleInput_2++;

/**
 * [tOracleInput_2 main ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_mail main ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_mail";

	

			//mail
			//mail


			
				if(execStat){
					runStat.updateStatOnConnection("mail"+iterateId,1, 1);
				} 
			

		


			   
			   

					mailStruct mail_HashRow = new mailStruct();
					
				
					mail_HashRow.CODE_BARRE = mail.CODE_BARRE;
					
					mail_HashRow.TYPE = mail.TYPE;
					
					mail_HashRow.MAIL = mail.MAIL;
					
					mail_HashRow.PREF = mail.PREF;
					
					tHash_Lookup_mail.put(mail_HashRow);
				
            




 


	tos_count_tAdvancedXMLMapHash_mail++;

/**
 * [tAdvancedXMLMapHash_mail main ] stop
 */



	
	/**
	 * [tOracleInput_2 end ] start
	 */

	

	
	
	currentComponent="tOracleInput_2";

	

}
}finally{
stmt_tOracleInput_2.close();

}

globalMap.put("tOracleInput_2_NB_LINE",nb_line_tOracleInput_2);
 

ok_Hash.put("tOracleInput_2", true);
end_Hash.put("tOracleInput_2", System.currentTimeMillis());




/**
 * [tOracleInput_2 end ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_mail end ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_mail";

	

tHash_Lookup_mail.endPut();

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("mail"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tAdvancedXMLMapHash_mail", true);
end_Hash.put("tAdvancedXMLMapHash_mail", System.currentTimeMillis());




/**
 * [tAdvancedXMLMapHash_mail end ] stop
 */



				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleInput_2 finally ] start
	 */

	

	
	
	currentComponent="tOracleInput_2";

	

 



/**
 * [tOracleInput_2 finally ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_mail finally ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_mail";

	

 



/**
 * [tAdvancedXMLMapHash_mail finally ] stop
 */



				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleInput_2_SUBPROCESS_STATE", 1);
	}
	


public static class adresseStruct implements routines.system.IPersistableComparableLookupRow<adresseStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];
	protected static final int DEFAULT_HASHCODE = 1;
    protected static final int PRIME = 31;
    protected int hashCode = DEFAULT_HASHCODE;
    public boolean hashCodeDirty = true;

    public String loopKey;



	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String TYPE;

				public String getTYPE () {
					return this.TYPE;
				}
				
			    public String ADR1;

				public String getADR1 () {
					return this.ADR1;
				}
				
			    public String ADR2;

				public String getADR2 () {
					return this.ADR2;
				}
				
			    public String ADR3;

				public String getADR3 () {
					return this.ADR3;
				}
				
			    public String ADR4;

				public String getADR4 () {
					return this.ADR4;
				}
				
			    public String ADR5;

				public String getADR5 () {
					return this.ADR5;
				}
				
			    public String VILLE;

				public String getVILLE () {
					return this.VILLE;
				}
				
			    public String CP;

				public String getCP () {
					return this.CP;
				}
				
			    public String PAYS;

				public String getPAYS () {
					return this.PAYS;
				}
				
			    public java.util.Date DEBUT;

				public java.util.Date getDEBUT () {
					return this.DEBUT;
				}
				


	@Override
	public int hashCode() {
		if (this.hashCodeDirty) {
			final int prime = PRIME;
			int result = DEFAULT_HASHCODE;
	
						result = prime * result + ((this.CODE_BARRE == null) ? 0 : this.CODE_BARRE.hashCode());
					
    		this.hashCode = result;
    		this.hashCodeDirty = false;
		}
		return this.hashCode;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
		if (obj == null) return false;
		if (getClass() != obj.getClass()) return false;
		final adresseStruct other = (adresseStruct) obj;
		
						if (this.CODE_BARRE == null) {
							if (other.CODE_BARRE != null)
								return false;
						
						} else if (!this.CODE_BARRE.equals(other.CODE_BARRE))
						
							return false;
					

		return true;
    }

	public void copyDataTo(adresseStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            other.TYPE = this.TYPE;
	            other.ADR1 = this.ADR1;
	            other.ADR2 = this.ADR2;
	            other.ADR3 = this.ADR3;
	            other.ADR4 = this.ADR4;
	            other.ADR5 = this.ADR5;
	            other.VILLE = this.VILLE;
	            other.CP = this.CP;
	            other.PAYS = this.PAYS;
	            other.DEBUT = this.DEBUT;
	            
	}

	public void copyKeysDataTo(adresseStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            	
	}




	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private String readString(DataInputStream dis, ObjectInputStream ois) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			byte[] byteArray = new byte[length];
			dis.read(byteArray);
			strReturn = new String(byteArray, utf8Charset);
		}
		return strReturn;
	}

	private void writeString(String str, DataOutputStream dos, ObjectOutputStream oos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
	}

	private java.util.Date readDate(DataInputStream dis, ObjectInputStream ois) throws IOException{
		java.util.Date dateReturn = null;
		int length = 0;
        length = dis.readByte();
		if (length == -1) {
			dateReturn = null;
		} else {
	    	dateReturn = new Date(dis.readLong());
		}
		return dateReturn;
	}

	private void writeDate(java.util.Date date1, DataOutputStream dos, ObjectOutputStream oos) throws IOException{
		if(date1 == null) {
            dos.writeByte(-1);
		} else {
			dos.writeByte(0);
	    	dos.writeLong(date1.getTime());
    	}
	}

    public void readKeysData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeKeysData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }



    /**
     * Fill Values data by reading ObjectInputStream.
     */
    public void readValuesData(DataInputStream dis, ObjectInputStream ois) {
        try {

			int length = 0;
		
						this.TYPE = readString(dis,ois);
					
						this.ADR1 = readString(dis,ois);
					
						this.ADR2 = readString(dis,ois);
					
						this.ADR3 = readString(dis,ois);
					
						this.ADR4 = readString(dis,ois);
					
						this.ADR5 = readString(dis,ois);
					
						this.VILLE = readString(dis,ois);
					
						this.CP = readString(dis,ois);
					
						this.PAYS = readString(dis,ois);
					
						this.DEBUT = readDate(dis,ois);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

    }

    /**
     * Return a byte array which represents Values data.
     */
    public void writeValuesData(DataOutputStream dos, ObjectOutputStream oos) {
        try {

		
						writeString(this.TYPE, dos, oos);
					
						writeString(this.ADR1, dos, oos);
					
						writeString(this.ADR2, dos, oos);
					
						writeString(this.ADR3, dos, oos);
					
						writeString(this.ADR4, dos, oos);
					
						writeString(this.ADR5, dos, oos);
					
						writeString(this.VILLE, dos, oos);
					
						writeString(this.CP, dos, oos);
					
						writeString(this.PAYS, dos, oos);
					
						writeDate(this.DEBUT, dos, oos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        	}

    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",TYPE="+TYPE);
		sb.append(",ADR1="+ADR1);
		sb.append(",ADR2="+ADR2);
		sb.append(",ADR3="+ADR3);
		sb.append(",ADR4="+ADR4);
		sb.append(",ADR5="+ADR5);
		sb.append(",VILLE="+VILLE);
		sb.append(",CP="+CP);
		sb.append(",PAYS="+PAYS);
		sb.append(",DEBUT="+String.valueOf(DEBUT));
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(adresseStruct other) {

		int returnValue = -1;
		
						returnValue = checkNullsAndCompare(this.CODE_BARRE, other.CODE_BARRE);
						if(returnValue != 0) {
							return returnValue;
						}

					
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tOracleInput_3Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleInput_3_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		adresseStruct adresse = new adresseStruct();




	
	/**
	 * [tAdvancedXMLMapHash_adresse begin ] start
	 */

	

	
		
		ok_Hash.put("tAdvancedXMLMapHash_adresse", false);
		start_Hash.put("tAdvancedXMLMapHash_adresse", System.currentTimeMillis());
		
	
	currentComponent="tAdvancedXMLMapHash_adresse";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("adresse" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tAdvancedXMLMapHash_adresse = 0;
		
    	class BytesLimit65535_tAdvancedXMLMapHash_adresse{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tAdvancedXMLMapHash_adresse().limitLog4jByte();

			   		// connection name:adresse
			   		// source node:tOracleInput_3 - inputs:(after_tOracleInput_1) outputs:(adresse,adresse) | target node:tAdvancedXMLMapHash_adresse - inputs:(adresse) outputs:()
			   		// linked node: tXMLMap_1 - inputs:(infogene,mail,adresse,telephone,statistiques) outputs:(xml)
			   
			   		org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE matchingModeEnum_adresse = 
			   			org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE.UNIQUE_MATCH;
			   
			   
	   				org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<adresseStruct> tHash_Lookup_adresse = 
	   					org.talend.designer.components.lookup.memory.AdvancedMemoryLookup.
	   						<adresseStruct>getLookup(matchingModeEnum_adresse);

		   	   	   globalMap.put("tHash_Lookup_adresse", tHash_Lookup_adresse);
		   	   	   
				
            

 



/**
 * [tAdvancedXMLMapHash_adresse begin ] stop
 */



	
	/**
	 * [tOracleInput_3 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleInput_3", false);
		start_Hash.put("tOracleInput_3", System.currentTimeMillis());
		
	
	currentComponent="tOracleInput_3";

	
		int tos_count_tOracleInput_3 = 0;
		
    	class BytesLimit65535_tOracleInput_3{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleInput_3().limitLog4jByte();
	


	
		    int nb_line_tOracleInput_3 = 0;
		    java.sql.Connection conn_tOracleInput_3 = null;
		        conn_tOracleInput_3 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
				
				if(((oracle.jdbc.OracleConnection)conn_tOracleInput_3).getSessionTimeZone() == null){
					java.sql.Statement stmtGetTZ_tOracleInput_3 = conn_tOracleInput_3.createStatement();
					java.sql.ResultSet rsGetTZ_tOracleInput_3 = stmtGetTZ_tOracleInput_3.executeQuery("select sessiontimezone from dual");
					String sessionTimezone_tOracleInput_3 = java.util.TimeZone.getDefault().getID();
					while (rsGetTZ_tOracleInput_3.next()) {
						sessionTimezone_tOracleInput_3 = rsGetTZ_tOracleInput_3.getString(1);
					}
					((oracle.jdbc.OracleConnection)conn_tOracleInput_3).setSessionTimeZone(sessionTimezone_tOracleInput_3);
				}
			
		    
			java.sql.Statement stmt_tOracleInput_3 = conn_tOracleInput_3.createStatement();

		    String dbquery_tOracleInput_3 = "SELECT \n  "+context.oracle_schema+".V_SGBMP_ADRESSE.*\nFROM "+context.oracle_schema+".V_SGBMP_ADRESSE";
			

            	globalMap.put("tOracleInput_3_QUERY",dbquery_tOracleInput_3);
		    java.sql.ResultSet rs_tOracleInput_3 = null;

		    try {
		    	rs_tOracleInput_3 = stmt_tOracleInput_3.executeQuery(dbquery_tOracleInput_3);
		    	java.sql.ResultSetMetaData rsmd_tOracleInput_3 = rs_tOracleInput_3.getMetaData();
		    	int colQtyInRs_tOracleInput_3 = rsmd_tOracleInput_3.getColumnCount();

		    String tmpContent_tOracleInput_3 = null;
		    
		    
		    while (rs_tOracleInput_3.next()) {
		        nb_line_tOracleInput_3++;
		        
							if(colQtyInRs_tOracleInput_3 < 1) {
								adresse.CODE_BARRE = null;
							} else {
	                         		
        	adresse.CODE_BARRE = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 1, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 2) {
								adresse.TYPE = null;
							} else {
	                         		
        	adresse.TYPE = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 2, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 3) {
								adresse.ADR1 = null;
							} else {
	                         		
        	adresse.ADR1 = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 3, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 4) {
								adresse.ADR2 = null;
							} else {
	                         		
        	adresse.ADR2 = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 4, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 5) {
								adresse.ADR3 = null;
							} else {
	                         		
        	adresse.ADR3 = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 5, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 6) {
								adresse.ADR4 = null;
							} else {
	                         		
        	adresse.ADR4 = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 6, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 7) {
								adresse.ADR5 = null;
							} else {
	                         		
        	adresse.ADR5 = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 7, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 8) {
								adresse.VILLE = null;
							} else {
	                         		
        	adresse.VILLE = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 8, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 9) {
								adresse.CP = null;
							} else {
	                         		
        	adresse.CP = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 9, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 10) {
								adresse.PAYS = null;
							} else {
	                         		
        	adresse.PAYS = routines.system.JDBCUtil.getString(rs_tOracleInput_3, 10, false);
		                    }
							if(colQtyInRs_tOracleInput_3 < 11) {
								adresse.DEBUT = null;
							} else {
										
			adresse.DEBUT = routines.system.JDBCUtil.getDate(rs_tOracleInput_3, 11);
		                    }
					




 



/**
 * [tOracleInput_3 begin ] stop
 */
	
	/**
	 * [tOracleInput_3 main ] start
	 */

	

	
	
	currentComponent="tOracleInput_3";

	

 


	tos_count_tOracleInput_3++;

/**
 * [tOracleInput_3 main ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_adresse main ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_adresse";

	

			//adresse
			//adresse


			
				if(execStat){
					runStat.updateStatOnConnection("adresse"+iterateId,1, 1);
				} 
			

		


			   
			   

					adresseStruct adresse_HashRow = new adresseStruct();
					
				
					adresse_HashRow.CODE_BARRE = adresse.CODE_BARRE;
					
					adresse_HashRow.TYPE = adresse.TYPE;
					
					adresse_HashRow.ADR1 = adresse.ADR1;
					
					adresse_HashRow.ADR2 = adresse.ADR2;
					
					adresse_HashRow.ADR3 = adresse.ADR3;
					
					adresse_HashRow.ADR4 = adresse.ADR4;
					
					adresse_HashRow.ADR5 = adresse.ADR5;
					
					adresse_HashRow.VILLE = adresse.VILLE;
					
					adresse_HashRow.CP = adresse.CP;
					
					adresse_HashRow.PAYS = adresse.PAYS;
					
					adresse_HashRow.DEBUT = adresse.DEBUT;
					
					tHash_Lookup_adresse.put(adresse_HashRow);
				
            




 


	tos_count_tAdvancedXMLMapHash_adresse++;

/**
 * [tAdvancedXMLMapHash_adresse main ] stop
 */



	
	/**
	 * [tOracleInput_3 end ] start
	 */

	

	
	
	currentComponent="tOracleInput_3";

	

}
}finally{
stmt_tOracleInput_3.close();

}

globalMap.put("tOracleInput_3_NB_LINE",nb_line_tOracleInput_3);
 

ok_Hash.put("tOracleInput_3", true);
end_Hash.put("tOracleInput_3", System.currentTimeMillis());




/**
 * [tOracleInput_3 end ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_adresse end ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_adresse";

	

tHash_Lookup_adresse.endPut();

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("adresse"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tAdvancedXMLMapHash_adresse", true);
end_Hash.put("tAdvancedXMLMapHash_adresse", System.currentTimeMillis());




/**
 * [tAdvancedXMLMapHash_adresse end ] stop
 */



				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleInput_3 finally ] start
	 */

	

	
	
	currentComponent="tOracleInput_3";

	

 



/**
 * [tOracleInput_3 finally ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_adresse finally ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_adresse";

	

 



/**
 * [tAdvancedXMLMapHash_adresse finally ] stop
 */



				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleInput_3_SUBPROCESS_STATE", 1);
	}
	


public static class telephoneStruct implements routines.system.IPersistableComparableLookupRow<telephoneStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];
	protected static final int DEFAULT_HASHCODE = 1;
    protected static final int PRIME = 31;
    protected int hashCode = DEFAULT_HASHCODE;
    public boolean hashCodeDirty = true;

    public String loopKey;



	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String TYPE;

				public String getTYPE () {
					return this.TYPE;
				}
				
			    public String NUMERO;

				public String getNUMERO () {
					return this.NUMERO;
				}
				
			    public String PREF;

				public String getPREF () {
					return this.PREF;
				}
				
			    public String SMS_PREF;

				public String getSMS_PREF () {
					return this.SMS_PREF;
				}
				


	@Override
	public int hashCode() {
		if (this.hashCodeDirty) {
			final int prime = PRIME;
			int result = DEFAULT_HASHCODE;
	
						result = prime * result + ((this.CODE_BARRE == null) ? 0 : this.CODE_BARRE.hashCode());
					
    		this.hashCode = result;
    		this.hashCodeDirty = false;
		}
		return this.hashCode;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
		if (obj == null) return false;
		if (getClass() != obj.getClass()) return false;
		final telephoneStruct other = (telephoneStruct) obj;
		
						if (this.CODE_BARRE == null) {
							if (other.CODE_BARRE != null)
								return false;
						
						} else if (!this.CODE_BARRE.equals(other.CODE_BARRE))
						
							return false;
					

		return true;
    }

	public void copyDataTo(telephoneStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            other.TYPE = this.TYPE;
	            other.NUMERO = this.NUMERO;
	            other.PREF = this.PREF;
	            other.SMS_PREF = this.SMS_PREF;
	            
	}

	public void copyKeysDataTo(telephoneStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            	
	}




	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private String readString(DataInputStream dis, ObjectInputStream ois) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			byte[] byteArray = new byte[length];
			dis.read(byteArray);
			strReturn = new String(byteArray, utf8Charset);
		}
		return strReturn;
	}

	private void writeString(String str, DataOutputStream dos, ObjectOutputStream oos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
	}

    public void readKeysData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeKeysData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }



    /**
     * Fill Values data by reading ObjectInputStream.
     */
    public void readValuesData(DataInputStream dis, ObjectInputStream ois) {
        try {

			int length = 0;
		
						this.TYPE = readString(dis,ois);
					
						this.NUMERO = readString(dis,ois);
					
						this.PREF = readString(dis,ois);
					
						this.SMS_PREF = readString(dis,ois);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

    }

    /**
     * Return a byte array which represents Values data.
     */
    public void writeValuesData(DataOutputStream dos, ObjectOutputStream oos) {
        try {

		
						writeString(this.TYPE, dos, oos);
					
						writeString(this.NUMERO, dos, oos);
					
						writeString(this.PREF, dos, oos);
					
						writeString(this.SMS_PREF, dos, oos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        	}

    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",TYPE="+TYPE);
		sb.append(",NUMERO="+NUMERO);
		sb.append(",PREF="+PREF);
		sb.append(",SMS_PREF="+SMS_PREF);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(telephoneStruct other) {

		int returnValue = -1;
		
						returnValue = checkNullsAndCompare(this.CODE_BARRE, other.CODE_BARRE);
						if(returnValue != 0) {
							return returnValue;
						}

					
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tOracleInput_4Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleInput_4_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		telephoneStruct telephone = new telephoneStruct();




	
	/**
	 * [tAdvancedXMLMapHash_telephone begin ] start
	 */

	

	
		
		ok_Hash.put("tAdvancedXMLMapHash_telephone", false);
		start_Hash.put("tAdvancedXMLMapHash_telephone", System.currentTimeMillis());
		
	
	currentComponent="tAdvancedXMLMapHash_telephone";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("telephone" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tAdvancedXMLMapHash_telephone = 0;
		
    	class BytesLimit65535_tAdvancedXMLMapHash_telephone{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tAdvancedXMLMapHash_telephone().limitLog4jByte();

			   		// connection name:telephone
			   		// source node:tOracleInput_4 - inputs:(after_tOracleInput_1) outputs:(telephone,telephone) | target node:tAdvancedXMLMapHash_telephone - inputs:(telephone) outputs:()
			   		// linked node: tXMLMap_1 - inputs:(infogene,mail,adresse,telephone,statistiques) outputs:(xml)
			   
			   		org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE matchingModeEnum_telephone = 
			   			org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE.UNIQUE_MATCH;
			   
			   
	   				org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<telephoneStruct> tHash_Lookup_telephone = 
	   					org.talend.designer.components.lookup.memory.AdvancedMemoryLookup.
	   						<telephoneStruct>getLookup(matchingModeEnum_telephone);

		   	   	   globalMap.put("tHash_Lookup_telephone", tHash_Lookup_telephone);
		   	   	   
				
            

 



/**
 * [tAdvancedXMLMapHash_telephone begin ] stop
 */



	
	/**
	 * [tOracleInput_4 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleInput_4", false);
		start_Hash.put("tOracleInput_4", System.currentTimeMillis());
		
	
	currentComponent="tOracleInput_4";

	
		int tos_count_tOracleInput_4 = 0;
		
    	class BytesLimit65535_tOracleInput_4{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleInput_4().limitLog4jByte();
	


	
		    int nb_line_tOracleInput_4 = 0;
		    java.sql.Connection conn_tOracleInput_4 = null;
		        conn_tOracleInput_4 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
				
				if(((oracle.jdbc.OracleConnection)conn_tOracleInput_4).getSessionTimeZone() == null){
					java.sql.Statement stmtGetTZ_tOracleInput_4 = conn_tOracleInput_4.createStatement();
					java.sql.ResultSet rsGetTZ_tOracleInput_4 = stmtGetTZ_tOracleInput_4.executeQuery("select sessiontimezone from dual");
					String sessionTimezone_tOracleInput_4 = java.util.TimeZone.getDefault().getID();
					while (rsGetTZ_tOracleInput_4.next()) {
						sessionTimezone_tOracleInput_4 = rsGetTZ_tOracleInput_4.getString(1);
					}
					((oracle.jdbc.OracleConnection)conn_tOracleInput_4).setSessionTimeZone(sessionTimezone_tOracleInput_4);
				}
			
		    
			java.sql.Statement stmt_tOracleInput_4 = conn_tOracleInput_4.createStatement();

		    String dbquery_tOracleInput_4 = "SELECT \n  "+context.oracle_schema+".V_SGBMP_TELEPHONE.*\nFROM "+context.oracle_schema+".V_SGBMP_TELEPHONE";
			

            	globalMap.put("tOracleInput_4_QUERY",dbquery_tOracleInput_4);
		    java.sql.ResultSet rs_tOracleInput_4 = null;

		    try {
		    	rs_tOracleInput_4 = stmt_tOracleInput_4.executeQuery(dbquery_tOracleInput_4);
		    	java.sql.ResultSetMetaData rsmd_tOracleInput_4 = rs_tOracleInput_4.getMetaData();
		    	int colQtyInRs_tOracleInput_4 = rsmd_tOracleInput_4.getColumnCount();

		    String tmpContent_tOracleInput_4 = null;
		    
		    
		    while (rs_tOracleInput_4.next()) {
		        nb_line_tOracleInput_4++;
		        
							if(colQtyInRs_tOracleInput_4 < 1) {
								telephone.CODE_BARRE = null;
							} else {
	                         		
        	telephone.CODE_BARRE = routines.system.JDBCUtil.getString(rs_tOracleInput_4, 1, false);
		                    }
							if(colQtyInRs_tOracleInput_4 < 2) {
								telephone.TYPE = null;
							} else {
	                         		
        	telephone.TYPE = routines.system.JDBCUtil.getString(rs_tOracleInput_4, 2, false);
		                    }
							if(colQtyInRs_tOracleInput_4 < 3) {
								telephone.NUMERO = null;
							} else {
	                         		
        	telephone.NUMERO = routines.system.JDBCUtil.getString(rs_tOracleInput_4, 3, false);
		                    }
							if(colQtyInRs_tOracleInput_4 < 4) {
								telephone.PREF = null;
							} else {
	                         		
        	telephone.PREF = routines.system.JDBCUtil.getString(rs_tOracleInput_4, 4, false);
		                    }
							if(colQtyInRs_tOracleInput_4 < 5) {
								telephone.SMS_PREF = null;
							} else {
	                         		
        	telephone.SMS_PREF = routines.system.JDBCUtil.getString(rs_tOracleInput_4, 5, false);
		                    }
					




 



/**
 * [tOracleInput_4 begin ] stop
 */
	
	/**
	 * [tOracleInput_4 main ] start
	 */

	

	
	
	currentComponent="tOracleInput_4";

	

 


	tos_count_tOracleInput_4++;

/**
 * [tOracleInput_4 main ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_telephone main ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_telephone";

	

			//telephone
			//telephone


			
				if(execStat){
					runStat.updateStatOnConnection("telephone"+iterateId,1, 1);
				} 
			

		


			   
			   

					telephoneStruct telephone_HashRow = new telephoneStruct();
					
				
					telephone_HashRow.CODE_BARRE = telephone.CODE_BARRE;
					
					telephone_HashRow.TYPE = telephone.TYPE;
					
					telephone_HashRow.NUMERO = telephone.NUMERO;
					
					telephone_HashRow.PREF = telephone.PREF;
					
					telephone_HashRow.SMS_PREF = telephone.SMS_PREF;
					
					tHash_Lookup_telephone.put(telephone_HashRow);
				
            




 


	tos_count_tAdvancedXMLMapHash_telephone++;

/**
 * [tAdvancedXMLMapHash_telephone main ] stop
 */



	
	/**
	 * [tOracleInput_4 end ] start
	 */

	

	
	
	currentComponent="tOracleInput_4";

	

}
}finally{
stmt_tOracleInput_4.close();

}

globalMap.put("tOracleInput_4_NB_LINE",nb_line_tOracleInput_4);
 

ok_Hash.put("tOracleInput_4", true);
end_Hash.put("tOracleInput_4", System.currentTimeMillis());




/**
 * [tOracleInput_4 end ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_telephone end ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_telephone";

	

tHash_Lookup_telephone.endPut();

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("telephone"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tAdvancedXMLMapHash_telephone", true);
end_Hash.put("tAdvancedXMLMapHash_telephone", System.currentTimeMillis());




/**
 * [tAdvancedXMLMapHash_telephone end ] stop
 */



				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleInput_4 finally ] start
	 */

	

	
	
	currentComponent="tOracleInput_4";

	

 



/**
 * [tOracleInput_4 finally ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_telephone finally ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_telephone";

	

 



/**
 * [tAdvancedXMLMapHash_telephone finally ] stop
 */



				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleInput_4_SUBPROCESS_STATE", 1);
	}
	


public static class statistiquesStruct implements routines.system.IPersistableComparableLookupRow<statistiquesStruct> {
    final static byte[] commonByteArrayLock_LDAP_sgbm_export = new byte[0];
    static byte[] commonByteArray_LDAP_sgbm_export = new byte[0];
	protected static final int DEFAULT_HASHCODE = 1;
    protected static final int PRIME = 31;
    protected int hashCode = DEFAULT_HASHCODE;
    public boolean hashCodeDirty = true;

    public String loopKey;



	
			    public String CODE_BARRE;

				public String getCODE_BARRE () {
					return this.CODE_BARRE;
				}
				
			    public String TYPE;

				public String getTYPE () {
					return this.TYPE;
				}
				
			    public String CATEGORIE;

				public String getCATEGORIE () {
					return this.CATEGORIE;
				}
				


	@Override
	public int hashCode() {
		if (this.hashCodeDirty) {
			final int prime = PRIME;
			int result = DEFAULT_HASHCODE;
	
						result = prime * result + ((this.CODE_BARRE == null) ? 0 : this.CODE_BARRE.hashCode());
					
    		this.hashCode = result;
    		this.hashCodeDirty = false;
		}
		return this.hashCode;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
		if (obj == null) return false;
		if (getClass() != obj.getClass()) return false;
		final statistiquesStruct other = (statistiquesStruct) obj;
		
						if (this.CODE_BARRE == null) {
							if (other.CODE_BARRE != null)
								return false;
						
						} else if (!this.CODE_BARRE.equals(other.CODE_BARRE))
						
							return false;
					

		return true;
    }

	public void copyDataTo(statistiquesStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            other.TYPE = this.TYPE;
	            other.CATEGORIE = this.CATEGORIE;
	            
	}

	public void copyKeysDataTo(statistiquesStruct other) {

		other.CODE_BARRE = this.CODE_BARRE;
	            	
	}




	private String readString(ObjectInputStream dis) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			if(length > commonByteArray_LDAP_sgbm_export.length) {
				if(length < 1024 && commonByteArray_LDAP_sgbm_export.length == 0) {
   					commonByteArray_LDAP_sgbm_export = new byte[1024];
				} else {
   					commonByteArray_LDAP_sgbm_export = new byte[2 * length];
   				}
			}
			dis.readFully(commonByteArray_LDAP_sgbm_export, 0, length);
			strReturn = new String(commonByteArray_LDAP_sgbm_export, 0, length, utf8Charset);
		}
		return strReturn;
	}

    private void writeString(String str, ObjectOutputStream dos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
    }

	private String readString(DataInputStream dis, ObjectInputStream ois) throws IOException{
		String strReturn = null;
		int length = 0;
        length = dis.readInt();
		if (length == -1) {
			strReturn = null;
		} else {
			byte[] byteArray = new byte[length];
			dis.read(byteArray);
			strReturn = new String(byteArray, utf8Charset);
		}
		return strReturn;
	}

	private void writeString(String str, DataOutputStream dos, ObjectOutputStream oos) throws IOException{
		if(str == null) {
            dos.writeInt(-1);
		} else {
            byte[] byteArray = str.getBytes(utf8Charset);
	    	dos.writeInt(byteArray.length);
			dos.write(byteArray);
    	}
	}

    public void readKeysData(ObjectInputStream dis) {

		synchronized(commonByteArrayLock_LDAP_sgbm_export) {

        	try {

        		int length = 0;
		
					this.CODE_BARRE = readString(dis);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

      }


    }

    public void writeKeysData(ObjectOutputStream dos) {
        try {

		
					// String
				
						writeString(this.CODE_BARRE,dos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        }


    }



    /**
     * Fill Values data by reading ObjectInputStream.
     */
    public void readValuesData(DataInputStream dis, ObjectInputStream ois) {
        try {

			int length = 0;
		
						this.TYPE = readString(dis,ois);
					
						this.CATEGORIE = readString(dis,ois);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);

		

        }

		

    }

    /**
     * Return a byte array which represents Values data.
     */
    public void writeValuesData(DataOutputStream dos, ObjectOutputStream oos) {
        try {

		
						writeString(this.TYPE, dos, oos);
					
						writeString(this.CATEGORIE, dos, oos);
					
        	} catch (IOException e) {
	            throw new RuntimeException(e);
        	}

    }


    public String toString() {

		StringBuilder sb = new StringBuilder();
		sb.append(super.toString());
		sb.append("[");
		sb.append("CODE_BARRE="+CODE_BARRE);
		sb.append(",TYPE="+TYPE);
		sb.append(",CATEGORIE="+CATEGORIE);
	    sb.append("]");

	    return sb.toString();
    }

    /**
     * Compare keys
     */
    public int compareTo(statistiquesStruct other) {

		int returnValue = -1;
		
						returnValue = checkNullsAndCompare(this.CODE_BARRE, other.CODE_BARRE);
						if(returnValue != 0) {
							return returnValue;
						}

					
	    return returnValue;
    }


    private int checkNullsAndCompare(Object object1, Object object2) {
        int returnValue = 0;
		if (object1 instanceof Comparable && object2 instanceof Comparable) {
            returnValue = ((Comparable) object1).compareTo(object2);
        } else if (object1 != null && object2 != null) {
            returnValue = compareStrings(object1.toString(), object2.toString());
        } else if (object1 == null && object2 != null) {
            returnValue = 1;
        } else if (object1 != null && object2 == null) {
            returnValue = -1;
        } else {
            returnValue = 0;
        }

        return returnValue;
    }

    private int compareStrings(String string1, String string2) {
        return string1.compareTo(string2);
    }


}
public void tOracleInput_5Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleInput_5_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		statistiquesStruct statistiques = new statistiquesStruct();




	
	/**
	 * [tAdvancedXMLMapHash_statistiques begin ] start
	 */

	

	
		
		ok_Hash.put("tAdvancedXMLMapHash_statistiques", false);
		start_Hash.put("tAdvancedXMLMapHash_statistiques", System.currentTimeMillis());
		
	
	currentComponent="tAdvancedXMLMapHash_statistiques";

	
			if (execStat) {
				if(resourceMap.get("inIterateVComp") == null){
					
						runStat.updateStatOnConnection("statistiques" + iterateId, 0, 0);
					
				}
			} 

		
		int tos_count_tAdvancedXMLMapHash_statistiques = 0;
		
    	class BytesLimit65535_tAdvancedXMLMapHash_statistiques{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tAdvancedXMLMapHash_statistiques().limitLog4jByte();

			   		// connection name:statistiques
			   		// source node:tOracleInput_5 - inputs:(after_tOracleInput_1) outputs:(statistiques,statistiques) | target node:tAdvancedXMLMapHash_statistiques - inputs:(statistiques) outputs:()
			   		// linked node: tXMLMap_1 - inputs:(infogene,mail,adresse,telephone,statistiques) outputs:(xml)
			   
			   		org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE matchingModeEnum_statistiques = 
			   			org.talend.designer.components.lookup.common.ICommonLookup.MATCHING_MODE.UNIQUE_MATCH;
			   
			   
	   				org.talend.designer.components.lookup.memory.AdvancedMemoryLookup<statistiquesStruct> tHash_Lookup_statistiques = 
	   					org.talend.designer.components.lookup.memory.AdvancedMemoryLookup.
	   						<statistiquesStruct>getLookup(matchingModeEnum_statistiques);

		   	   	   globalMap.put("tHash_Lookup_statistiques", tHash_Lookup_statistiques);
		   	   	   
				
            

 



/**
 * [tAdvancedXMLMapHash_statistiques begin ] stop
 */



	
	/**
	 * [tOracleInput_5 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleInput_5", false);
		start_Hash.put("tOracleInput_5", System.currentTimeMillis());
		
	
	currentComponent="tOracleInput_5";

	
		int tos_count_tOracleInput_5 = 0;
		
    	class BytesLimit65535_tOracleInput_5{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleInput_5().limitLog4jByte();
	


	
		    int nb_line_tOracleInput_5 = 0;
		    java.sql.Connection conn_tOracleInput_5 = null;
		        conn_tOracleInput_5 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
				
				if(((oracle.jdbc.OracleConnection)conn_tOracleInput_5).getSessionTimeZone() == null){
					java.sql.Statement stmtGetTZ_tOracleInput_5 = conn_tOracleInput_5.createStatement();
					java.sql.ResultSet rsGetTZ_tOracleInput_5 = stmtGetTZ_tOracleInput_5.executeQuery("select sessiontimezone from dual");
					String sessionTimezone_tOracleInput_5 = java.util.TimeZone.getDefault().getID();
					while (rsGetTZ_tOracleInput_5.next()) {
						sessionTimezone_tOracleInput_5 = rsGetTZ_tOracleInput_5.getString(1);
					}
					((oracle.jdbc.OracleConnection)conn_tOracleInput_5).setSessionTimeZone(sessionTimezone_tOracleInput_5);
				}
			
		    
			java.sql.Statement stmt_tOracleInput_5 = conn_tOracleInput_5.createStatement();

		    String dbquery_tOracleInput_5 = "SELECT \n  "+context.oracle_schema+".V_SGBMP_STATISTIQUES.*\nFROM "+context.oracle_schema+".V_SGBMP_STATISTIQUES";
			

            	globalMap.put("tOracleInput_5_QUERY",dbquery_tOracleInput_5);
		    java.sql.ResultSet rs_tOracleInput_5 = null;

		    try {
		    	rs_tOracleInput_5 = stmt_tOracleInput_5.executeQuery(dbquery_tOracleInput_5);
		    	java.sql.ResultSetMetaData rsmd_tOracleInput_5 = rs_tOracleInput_5.getMetaData();
		    	int colQtyInRs_tOracleInput_5 = rsmd_tOracleInput_5.getColumnCount();

		    String tmpContent_tOracleInput_5 = null;
		    
		    
		    while (rs_tOracleInput_5.next()) {
		        nb_line_tOracleInput_5++;
		        
							if(colQtyInRs_tOracleInput_5 < 1) {
								statistiques.CODE_BARRE = null;
							} else {
	                         		
        	statistiques.CODE_BARRE = routines.system.JDBCUtil.getString(rs_tOracleInput_5, 1, false);
		                    }
							if(colQtyInRs_tOracleInput_5 < 2) {
								statistiques.TYPE = null;
							} else {
	                         		
        	statistiques.TYPE = routines.system.JDBCUtil.getString(rs_tOracleInput_5, 2, false);
		                    }
							if(colQtyInRs_tOracleInput_5 < 3) {
								statistiques.CATEGORIE = null;
							} else {
	                         		
        	statistiques.CATEGORIE = routines.system.JDBCUtil.getString(rs_tOracleInput_5, 3, false);
		                    }
					




 



/**
 * [tOracleInput_5 begin ] stop
 */
	
	/**
	 * [tOracleInput_5 main ] start
	 */

	

	
	
	currentComponent="tOracleInput_5";

	

 


	tos_count_tOracleInput_5++;

/**
 * [tOracleInput_5 main ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_statistiques main ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_statistiques";

	

			//statistiques
			//statistiques


			
				if(execStat){
					runStat.updateStatOnConnection("statistiques"+iterateId,1, 1);
				} 
			

		


			   
			   

					statistiquesStruct statistiques_HashRow = new statistiquesStruct();
					
				
					statistiques_HashRow.CODE_BARRE = statistiques.CODE_BARRE;
					
					statistiques_HashRow.TYPE = statistiques.TYPE;
					
					statistiques_HashRow.CATEGORIE = statistiques.CATEGORIE;
					
					tHash_Lookup_statistiques.put(statistiques_HashRow);
				
            




 


	tos_count_tAdvancedXMLMapHash_statistiques++;

/**
 * [tAdvancedXMLMapHash_statistiques main ] stop
 */



	
	/**
	 * [tOracleInput_5 end ] start
	 */

	

	
	
	currentComponent="tOracleInput_5";

	

}
}finally{
stmt_tOracleInput_5.close();

}

globalMap.put("tOracleInput_5_NB_LINE",nb_line_tOracleInput_5);
 

ok_Hash.put("tOracleInput_5", true);
end_Hash.put("tOracleInput_5", System.currentTimeMillis());




/**
 * [tOracleInput_5 end ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_statistiques end ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_statistiques";

	

tHash_Lookup_statistiques.endPut();

			if(execStat){
				if(resourceMap.get("inIterateVComp") == null || !((Boolean)resourceMap.get("inIterateVComp"))){
			 		runStat.updateStatOnConnection("statistiques"+iterateId,2, 0); 
			 	}
			}
		
 

ok_Hash.put("tAdvancedXMLMapHash_statistiques", true);
end_Hash.put("tAdvancedXMLMapHash_statistiques", System.currentTimeMillis());




/**
 * [tAdvancedXMLMapHash_statistiques end ] stop
 */



				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleInput_5 finally ] start
	 */

	

	
	
	currentComponent="tOracleInput_5";

	

 



/**
 * [tOracleInput_5 finally ] stop
 */

	
	/**
	 * [tAdvancedXMLMapHash_statistiques finally ] start
	 */

	

	
	
	currentComponent="tAdvancedXMLMapHash_statistiques";

	

 



/**
 * [tAdvancedXMLMapHash_statistiques finally ] stop
 */



				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleInput_5_SUBPROCESS_STATE", 1);
	}
	

public void tPostjob_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tPostjob_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tPostjob_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tPostjob_1", false);
		start_Hash.put("tPostjob_1", System.currentTimeMillis());
		
	
	currentComponent="tPostjob_1";

	
		int tos_count_tPostjob_1 = 0;
		
    	class BytesLimit65535_tPostjob_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tPostjob_1().limitLog4jByte();

 



/**
 * [tPostjob_1 begin ] stop
 */
	
	/**
	 * [tPostjob_1 main ] start
	 */

	

	
	
	currentComponent="tPostjob_1";

	

 


	tos_count_tPostjob_1++;

/**
 * [tPostjob_1 main ] stop
 */
	
	/**
	 * [tPostjob_1 end ] start
	 */

	

	
	
	currentComponent="tPostjob_1";

	

 

ok_Hash.put("tPostjob_1", true);
end_Hash.put("tPostjob_1", System.currentTimeMillis());

				if(execStat){   
   	 				runStat.updateStatOnConnection("OnComponentOk2", 0, "ok");
				}
				tSCPClose_1Process(globalMap);



/**
 * [tPostjob_1 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tPostjob_1 finally ] start
	 */

	

	
	
	currentComponent="tPostjob_1";

	

 



/**
 * [tPostjob_1 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tPostjob_1_SUBPROCESS_STATE", 1);
	}
	

public void tSCPClose_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tSCPClose_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tSCPClose_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tSCPClose_1", false);
		start_Hash.put("tSCPClose_1", System.currentTimeMillis());
		
	
	currentComponent="tSCPClose_1";

	
		int tos_count_tSCPClose_1 = 0;
		
    	class BytesLimit65535_tSCPClose_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tSCPClose_1().limitLog4jByte();

 



/**
 * [tSCPClose_1 begin ] stop
 */
	
	/**
	 * [tSCPClose_1 main ] start
	 */

	

	
	
	currentComponent="tSCPClose_1";

	
	
 
	ch.ethz.ssh2.Connection conn_tSCPClose_1 = (ch.ethz.ssh2.Connection)globalMap.get("conn_tSCPConnection_1");
	if(conn_tSCPClose_1 != null){
		
		conn_tSCPClose_1.close();
		
	}

 


	tos_count_tSCPClose_1++;

/**
 * [tSCPClose_1 main ] stop
 */
	
	/**
	 * [tSCPClose_1 end ] start
	 */

	

	
	
	currentComponent="tSCPClose_1";

	

 

ok_Hash.put("tSCPClose_1", true);
end_Hash.put("tSCPClose_1", System.currentTimeMillis());

				if(execStat){   
   	 				runStat.updateStatOnConnection("OnComponentOk5", 0, "ok");
				}
				tOracleClose_1Process(globalMap);



/**
 * [tSCPClose_1 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tSCPClose_1 finally ] start
	 */

	

	
	
	currentComponent="tSCPClose_1";

	

 



/**
 * [tSCPClose_1 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tSCPClose_1_SUBPROCESS_STATE", 1);
	}
	

public void tOracleClose_1Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tOracleClose_1_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	
		String iterateId = "";
	
	
	String currentComponent = "";
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {

			String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
			boolean resumeIt = currentMethodName.equals(resumeEntryMethodName);
			if( resumeEntryMethodName == null || resumeIt || globalResumeTicket){//start the resume
				globalResumeTicket = true;





	
	/**
	 * [tOracleClose_1 begin ] start
	 */

	

	
		
		ok_Hash.put("tOracleClose_1", false);
		start_Hash.put("tOracleClose_1", System.currentTimeMillis());
		
	
	currentComponent="tOracleClose_1";

	
		int tos_count_tOracleClose_1 = 0;
		
    	class BytesLimit65535_tOracleClose_1{
    		public void limitLog4jByte() throws Exception{
    			
    		}
    	}
    	
        new BytesLimit65535_tOracleClose_1().limitLog4jByte();

 



/**
 * [tOracleClose_1 begin ] stop
 */
	
	/**
	 * [tOracleClose_1 main ] start
	 */

	

	
	
	currentComponent="tOracleClose_1";

	

	java.sql.Connection conn_tOracleClose_1 = (java.sql.Connection)globalMap.get("conn_tOracleConnection_1");
	
	if(conn_tOracleClose_1 != null && !conn_tOracleClose_1.isClosed())
	{
		
			conn_tOracleClose_1.close();
			
	}

 


	tos_count_tOracleClose_1++;

/**
 * [tOracleClose_1 main ] stop
 */
	
	/**
	 * [tOracleClose_1 end ] start
	 */

	

	
	
	currentComponent="tOracleClose_1";

	

 

ok_Hash.put("tOracleClose_1", true);
end_Hash.put("tOracleClose_1", System.currentTimeMillis());




/**
 * [tOracleClose_1 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tOracleClose_1 finally ] start
	 */

	

	
	
	currentComponent="tOracleClose_1";

	

 



/**
 * [tOracleClose_1 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tOracleClose_1_SUBPROCESS_STATE", 1);
	}
	
    public String resuming_logs_dir_path = null;
    public String resuming_checkpoint_path = null;
    public String parent_part_launcher = null;
    private String resumeEntryMethodName = null;
    private boolean globalResumeTicket = false;

    public boolean watch = false;
    // portStats is null, it means don't execute the statistics
    public Integer portStats = null;
    public int portTraces = 4334;
    public String clientHost;
    public String defaultClientHost = "localhost";
    public String contextStr = "Default";
    public boolean isDefaultContext = true;
    public String pid = "0";
    public String rootPid = null;
    public String fatherPid = null;
    public String fatherNode = null;
    public long startTime = 0;
    public boolean isChildJob = false;
    public String log4jLevel = "";

    private boolean execStat = true;

    private ThreadLocal<java.util.Map<String, String>> threadLocal = new ThreadLocal<java.util.Map<String, String>>() {
        protected java.util.Map<String, String> initialValue() {
            java.util.Map<String,String> threadRunResultMap = new java.util.HashMap<String, String>();
            threadRunResultMap.put("errorCode", null);
            threadRunResultMap.put("status", "");
            return threadRunResultMap;
        };
    };



    private PropertiesWithType context_param = new PropertiesWithType();
    public java.util.Map<String, Object> parentContextMap = new java.util.HashMap<String, Object>();

    public String status= "";

    public static void main(String[] args){
        final sgbm_export sgbm_exportClass = new sgbm_export();

        int exitCode = sgbm_exportClass.runJobInTOS(args);

        System.exit(exitCode);
    }


    public String[][] runJob(String[] args) {

        int exitCode = runJobInTOS(args);
        String[][] bufferValue = new String[][] { { Integer.toString(exitCode) } };

        return bufferValue;
    }

    public boolean hastBufferOutputComponent() {
		boolean hastBufferOutput = false;
    	
        return hastBufferOutput;
    }

    public int runJobInTOS(String[] args) {
	   	// reset status
	   	status = "";

        String lastStr = "";
        for (String arg : args) {
            if (arg.equalsIgnoreCase("--context_param")) {
                lastStr = arg;
            } else if (lastStr.equals("")) {
                evalParam(arg);
            } else {
                evalParam(lastStr + " " + arg);
                lastStr = "";
            }
        }


        if(clientHost == null) {
            clientHost = defaultClientHost;
        }

        if(pid == null || "0".equals(pid)) {
            pid = TalendString.getAsciiRandomString(6);
        }

        if (rootPid==null) {
            rootPid = pid;
        }
        if (fatherPid==null) {
            fatherPid = pid;
        }else{
            isChildJob = true;
        }

        if (portStats != null) {
            // portStats = -1; //for testing
            if (portStats < 0 || portStats > 65535) {
                // issue:10869, the portStats is invalid, so this client socket can't open
                System.err.println("The statistics socket port " + portStats + " is invalid.");
                execStat = false;
            }
        } else {
            execStat = false;
        }

        try {
            //call job/subjob with an existing context, like: --context=production. if without this parameter, there will use the default context instead.
            java.io.InputStream inContext = sgbm_export.class.getClassLoader().getResourceAsStream("ldap/sgbm_export_0_8/contexts/"+contextStr+".properties");
            if(isDefaultContext && inContext ==null) {

            } else {
                if (inContext!=null) {
                    //defaultProps is in order to keep the original context value
                    defaultProps.load(inContext);
                    inContext.close();
                    context = new ContextProperties(defaultProps);
                }else{
                    //print info and job continue to run, for case: context_param is not empty.
                    System.err.println("Could not find the context " + contextStr);
                }
            }

            if(!context_param.isEmpty()) {
                context.putAll(context_param);
				//set types for params from parentJobs
				for (Object key: context_param.keySet()){
					String context_key = key.toString();
					String context_type = context_param.getContextType(context_key);
					context.setContextType(context_key, context_type);

				}
            }
				    context.setContextType("sigb_record_type", "id_String");
				
                context.sigb_record_type=(String) context.getProperty("sigb_record_type");
				    context.setContextType("sigb_user_group", "id_String");
				
                context.sigb_user_group=(String) context.getProperty("sigb_user_group");
				    context.setContextType("sigb_user_group_desc", "id_String");
				
                context.sigb_user_group_desc=(String) context.getProperty("sigb_user_group_desc");
				    context.setContextType("sigb_external", "id_String");
				
                context.sigb_external=(String) context.getProperty("sigb_external");
				    context.setContextType("sigb_external_desc", "id_String");
				
                context.sigb_external_desc=(String) context.getProperty("sigb_external_desc");
				    context.setContextType("sigb_external_id", "id_String");
				
                context.sigb_external_id=(String) context.getProperty("sigb_external_id");
				    context.setContextType("sigb_active", "id_String");
				
                context.sigb_active=(String) context.getProperty("sigb_active");
				    context.setContextType("sigb_id_type_eppn", "id_String");
				
                context.sigb_id_type_eppn=(String) context.getProperty("sigb_id_type_eppn");
				    context.setContextType("sigb_cataloger_level_desc", "id_String");
				
                context.sigb_cataloger_level_desc=(String) context.getProperty("sigb_cataloger_level_desc");
				    context.setContextType("sigb_cataloger_level", "id_String");
				
                context.sigb_cataloger_level=(String) context.getProperty("sigb_cataloger_level");
				    context.setContextType("sigb_param_file", "id_String");
				
                context.sigb_param_file=(String) context.getProperty("sigb_param_file");
				    context.setContextType("oracle_schema", "id_String");
				
                context.oracle_schema=(String) context.getProperty("oracle_schema");
				    context.setContextType("oracle_server", "id_String");
				
                context.oracle_server=(String) context.getProperty("oracle_server");
				    context.setContextType("oracle_port", "id_String");
				
                context.oracle_port=(String) context.getProperty("oracle_port");
				    context.setContextType("oracle_login", "id_String");
				
                context.oracle_login=(String) context.getProperty("oracle_login");
				    context.setContextType("oracle_sid", "id_String");
				
                context.oracle_sid=(String) context.getProperty("oracle_sid");
				    context.setContextType("oracle_password", "id_String");
				
                context.oracle_password=(String) context.getProperty("oracle_password");
				    context.setContextType("sigb_files_dir", "id_String");
				
                context.sigb_files_dir=(String) context.getProperty("sigb_files_dir");
				    context.setContextType("sigb_biu_dir", "id_String");
				
                context.sigb_biu_dir=(String) context.getProperty("sigb_biu_dir");
				    context.setContextType("sigb_file_name", "id_String");
				
                context.sigb_file_name=(String) context.getProperty("sigb_file_name");
				    context.setContextType("sigb_biu_password", "id_String");
				
                context.sigb_biu_password=(String) context.getProperty("sigb_biu_password");
				    context.setContextType("sigb_biu_cle_publique", "id_String");
				
                context.sigb_biu_cle_publique=(String) context.getProperty("sigb_biu_cle_publique");
				    context.setContextType("sigb_biu_username", "id_String");
				
                context.sigb_biu_username=(String) context.getProperty("sigb_biu_username");
				    context.setContextType("sigb_biu_host", "id_String");
				
                context.sigb_biu_host=(String) context.getProperty("sigb_biu_host");
				    context.setContextType("sigb_biu_port", "id_Integer");
				
             try{
                 context.sigb_biu_port=routines.system.ParserUtils.parseTo_Integer (context.getProperty("sigb_biu_port"));
             }catch(NumberFormatException e){
                 context.sigb_biu_port=null;
              }
        } catch (java.io.IOException ie) {
            System.err.println("Could not load context "+contextStr);
            ie.printStackTrace();
        }


        // get context value from parent directly
        if (parentContextMap != null && !parentContextMap.isEmpty()) {if (parentContextMap.containsKey("sigb_record_type")) {
                context.sigb_record_type = (String) parentContextMap.get("sigb_record_type");
            }if (parentContextMap.containsKey("sigb_user_group")) {
                context.sigb_user_group = (String) parentContextMap.get("sigb_user_group");
            }if (parentContextMap.containsKey("sigb_user_group_desc")) {
                context.sigb_user_group_desc = (String) parentContextMap.get("sigb_user_group_desc");
            }if (parentContextMap.containsKey("sigb_external")) {
                context.sigb_external = (String) parentContextMap.get("sigb_external");
            }if (parentContextMap.containsKey("sigb_external_desc")) {
                context.sigb_external_desc = (String) parentContextMap.get("sigb_external_desc");
            }if (parentContextMap.containsKey("sigb_external_id")) {
                context.sigb_external_id = (String) parentContextMap.get("sigb_external_id");
            }if (parentContextMap.containsKey("sigb_active")) {
                context.sigb_active = (String) parentContextMap.get("sigb_active");
            }if (parentContextMap.containsKey("sigb_id_type_eppn")) {
                context.sigb_id_type_eppn = (String) parentContextMap.get("sigb_id_type_eppn");
            }if (parentContextMap.containsKey("sigb_cataloger_level_desc")) {
                context.sigb_cataloger_level_desc = (String) parentContextMap.get("sigb_cataloger_level_desc");
            }if (parentContextMap.containsKey("sigb_cataloger_level")) {
                context.sigb_cataloger_level = (String) parentContextMap.get("sigb_cataloger_level");
            }if (parentContextMap.containsKey("sigb_param_file")) {
                context.sigb_param_file = (String) parentContextMap.get("sigb_param_file");
            }if (parentContextMap.containsKey("oracle_schema")) {
                context.oracle_schema = (String) parentContextMap.get("oracle_schema");
            }if (parentContextMap.containsKey("oracle_server")) {
                context.oracle_server = (String) parentContextMap.get("oracle_server");
            }if (parentContextMap.containsKey("oracle_port")) {
                context.oracle_port = (String) parentContextMap.get("oracle_port");
            }if (parentContextMap.containsKey("oracle_login")) {
                context.oracle_login = (String) parentContextMap.get("oracle_login");
            }if (parentContextMap.containsKey("oracle_sid")) {
                context.oracle_sid = (String) parentContextMap.get("oracle_sid");
            }if (parentContextMap.containsKey("oracle_password")) {
                context.oracle_password = (String) parentContextMap.get("oracle_password");
            }if (parentContextMap.containsKey("sigb_files_dir")) {
                context.sigb_files_dir = (String) parentContextMap.get("sigb_files_dir");
            }if (parentContextMap.containsKey("sigb_biu_dir")) {
                context.sigb_biu_dir = (String) parentContextMap.get("sigb_biu_dir");
            }if (parentContextMap.containsKey("sigb_file_name")) {
                context.sigb_file_name = (String) parentContextMap.get("sigb_file_name");
            }if (parentContextMap.containsKey("sigb_biu_password")) {
                context.sigb_biu_password = (String) parentContextMap.get("sigb_biu_password");
            }if (parentContextMap.containsKey("sigb_biu_cle_publique")) {
                context.sigb_biu_cle_publique = (String) parentContextMap.get("sigb_biu_cle_publique");
            }if (parentContextMap.containsKey("sigb_biu_username")) {
                context.sigb_biu_username = (String) parentContextMap.get("sigb_biu_username");
            }if (parentContextMap.containsKey("sigb_biu_host")) {
                context.sigb_biu_host = (String) parentContextMap.get("sigb_biu_host");
            }if (parentContextMap.containsKey("sigb_biu_port")) {
                context.sigb_biu_port = (Integer) parentContextMap.get("sigb_biu_port");
            }
        }

        //Resume: init the resumeUtil
        resumeEntryMethodName = ResumeUtil.getResumeEntryMethodName(resuming_checkpoint_path);
        resumeUtil = new ResumeUtil(resuming_logs_dir_path, isChildJob, rootPid);
        resumeUtil.initCommonInfo(pid, rootPid, fatherPid, projectName, jobName, contextStr, jobVersion);

		List<String> parametersToEncrypt = new java.util.ArrayList<String>();
        //Resume: jobStart
        resumeUtil.addLog("JOB_STARTED", "JOB:" + jobName, parent_part_launcher, Thread.currentThread().getId() + "", "","","","",resumeUtil.convertToJsonText(context,parametersToEncrypt));

if(execStat) {
    try {
        runStat.openSocket(!isChildJob);
        runStat.setAllPID(rootPid, fatherPid, pid, jobName);
        runStat.startThreadStat(clientHost, portStats);
        runStat.updateStatOnJob(RunStat.JOBSTART, fatherNode);
    } catch (java.io.IOException ioException) {
        ioException.printStackTrace();
    }
}



	
	    java.util.concurrent.ConcurrentHashMap<Object, Object> concurrentHashMap = new java.util.concurrent.ConcurrentHashMap<Object, Object>();
	    globalMap.put("concurrentHashMap", concurrentHashMap);
	

    long startUsedMemory = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
    long endUsedMemory = 0;
    long end = 0;

    startTime = System.currentTimeMillis();




this.globalResumeTicket = true;//to run tPreJob

try {
errorCode = null;tPrejob_1Process(globalMap);
if(!"failure".equals(status)) { status = "end"; }
}catch (TalendException e_tPrejob_1) {
globalMap.put("tPrejob_1_SUBPROCESS_STATE", -1);

e_tPrejob_1.printStackTrace();

}



this.globalResumeTicket = false;//to run others jobs


this.globalResumeTicket = true;//to run tPostJob

try {
errorCode = null;tPostjob_1Process(globalMap);
if(!"failure".equals(status)) { status = "end"; }
}catch (TalendException e_tPostjob_1) {
globalMap.put("tPostjob_1_SUBPROCESS_STATE", -1);

e_tPostjob_1.printStackTrace();

}



        end = System.currentTimeMillis();

        if (watch) {
            System.out.println((end-startTime)+" milliseconds");
        }

        endUsedMemory = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
        if (false) {
            System.out.println((endUsedMemory - startUsedMemory) + " bytes memory increase when running : sgbm_export");
        }


    closeScpConnections();



if (execStat) {
    runStat.updateStatOnJob(RunStat.JOBEND, fatherNode);
    runStat.stopThreadStat();
}
    int returnCode = 0;
    if(errorCode == null) {
         returnCode = status != null && status.equals("failure") ? 1 : 0;
    } else {
         returnCode = errorCode.intValue();
    }
    resumeUtil.addLog("JOB_ENDED", "JOB:" + jobName, parent_part_launcher, Thread.currentThread().getId() + "", "","" + returnCode,"","","");

    return returnCode;

  }

    // only for OSGi env
    public void destroy() {
    closeScpConnections();
    closeSqlDbConnections();


    }


    private void closeScpConnections() {
        try {
            Object obj_conn;
            obj_conn = globalMap.remove("conn_tSCPConnection_1");
            if (null != obj_conn) {
                ((ch.ethz.ssh2.Connection) obj_conn).close();
            }
        } catch (java.lang.Exception e) {
        }
    }

    private void closeSqlDbConnections() {
        try {
            Object obj_conn;
            obj_conn = globalMap.remove("conn_tOracleConnection_1");
            if (null != obj_conn) {
                ((java.sql.Connection) obj_conn).close();
            }
        } catch (java.lang.Exception e) {
        }
    }











    private java.util.Map<String, Object> getSharedConnections4REST() {
        java.util.Map<String, Object> connections = new java.util.HashMap<String, Object>();
            connections.put("conn_tSCPConnection_1", globalMap.get("conn_tSCPConnection_1"));
            connections.put("conn_tOracleConnection_1", globalMap.get("conn_tOracleConnection_1"));







        return connections;
    }

    private void evalParam(String arg) {
        if (arg.startsWith("--resuming_logs_dir_path")) {
            resuming_logs_dir_path = arg.substring(25);
        } else if (arg.startsWith("--resuming_checkpoint_path")) {
            resuming_checkpoint_path = arg.substring(27);
        } else if (arg.startsWith("--parent_part_launcher")) {
            parent_part_launcher = arg.substring(23);
        } else if (arg.startsWith("--watch")) {
            watch = true;
        } else if (arg.startsWith("--stat_port=")) {
            String portStatsStr = arg.substring(12);
            if (portStatsStr != null && !portStatsStr.equals("null")) {
                portStats = Integer.parseInt(portStatsStr);
            }
        } else if (arg.startsWith("--trace_port=")) {
            portTraces = Integer.parseInt(arg.substring(13));
        } else if (arg.startsWith("--client_host=")) {
            clientHost = arg.substring(14);
        } else if (arg.startsWith("--context=")) {
            contextStr = arg.substring(10);
            isDefaultContext = false;
        } else if (arg.startsWith("--father_pid=")) {
            fatherPid = arg.substring(13);
        } else if (arg.startsWith("--root_pid=")) {
            rootPid = arg.substring(11);
        } else if (arg.startsWith("--father_node=")) {
            fatherNode = arg.substring(14);
        } else if (arg.startsWith("--pid=")) {
            pid = arg.substring(6);
        } else if (arg.startsWith("--context_type")) {
            String keyValue = arg.substring(15);
			int index = -1;
            if (keyValue != null && (index = keyValue.indexOf('=')) > -1) {
                if (fatherPid==null) {
                    context_param.setContextType(keyValue.substring(0, index), replaceEscapeChars(keyValue.substring(index + 1)));
                } else { // the subjob won't escape the especial chars
                    context_param.setContextType(keyValue.substring(0, index), keyValue.substring(index + 1) );
                }

            }

		} else if (arg.startsWith("--context_param")) {
            String keyValue = arg.substring(16);
            int index = -1;
            if (keyValue != null && (index = keyValue.indexOf('=')) > -1) {
                if (fatherPid==null) {
                    context_param.put(keyValue.substring(0, index), replaceEscapeChars(keyValue.substring(index + 1)));
                } else { // the subjob won't escape the especial chars
                    context_param.put(keyValue.substring(0, index), keyValue.substring(index + 1) );
                }
            }
        }else if (arg.startsWith("--log4jLevel=")) {
            log4jLevel = arg.substring(13);
		}

    }
    
    private static final String NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY = "<TALEND_NULL>";

    private final String[][] escapeChars = {
        {"\\\\","\\"},{"\\n","\n"},{"\\'","\'"},{"\\r","\r"},
        {"\\f","\f"},{"\\b","\b"},{"\\t","\t"}
        };
    private String replaceEscapeChars (String keyValue) {

		if (keyValue == null || ("").equals(keyValue.trim())) {
			return keyValue;
		}

		StringBuilder result = new StringBuilder();
		int currIndex = 0;
		while (currIndex < keyValue.length()) {
			int index = -1;
			// judege if the left string includes escape chars
			for (String[] strArray : escapeChars) {
				index = keyValue.indexOf(strArray[0],currIndex);
				if (index>=0) {

					result.append(keyValue.substring(currIndex, index + strArray[0].length()).replace(strArray[0], strArray[1]));
					currIndex = index + strArray[0].length();
					break;
				}
			}
			// if the left string doesn't include escape chars, append the left into the result
			if (index < 0) {
				result.append(keyValue.substring(currIndex));
				currIndex = currIndex + keyValue.length();
			}
		}

		return result.toString();
    }

    public Integer getErrorCode() {
        return errorCode;
    }


    public String getStatus() {
        return status;
    }

    ResumeUtil resumeUtil = null;
}
/************************************************************************************************
 *     241788 characters generated by Talend Open Studio for Data Integration 
 *     on the 7 mars 2018 16:12:22 CET
 ************************************************************************************************/